SystemOrganization addCategory: #WASM!

!String methodsFor: '*WASM' stamp: 'edc 12/5/2017 09:10'!
+ anObject
	"Concatenate the argument to the receiver.
		Transcript cr; show: 'The value is: ', 3.
	"
	^ self copyReplaceFrom: self size + 1
		  to: self size
		  with: anObject asString! !

!String methodsFor: '*WASM' stamp: 'edc 5/22/2019 07:50'!
asF32Wasm
| s b  i col swap|

	s := self asNumber asFloat f32 hex.
s = '0' ifTrue:[^#(0 0 0 0)].
	b := String new.
col := OrderedCollection new.
	i := 1.

	[b := b
		, (s at: i).
	b:= b
		, (s at: i + 1).
col addFirst: b asHexNumber.
b := String new.
	i < (s size - 1)]
		whileTrue: [i := i + 2].

 col size = 1 ifTrue: [
[col size =4] whileFalse:[col addFirst:0.
].^col].
col size = 2 ifTrue:[swap := col at: 1.
	col
		at: 1
		put: (col at: 2).
	col at: 2 put: swap.

[col size =4] whileFalse:[col addFirst:0].^col].
col size = 4 ifTrue:[col:= col reverse].
^col.! !

!String methodsFor: '*WASM' stamp: 'edc 2/12/2018 11:40'!
asHexNumber 
	"Answer the Number created by interpreting the receiver as the string 
	representation of a number."


^('16r' , self) asNumber! !

!String methodsFor: '*WASM' stamp: 'edc 5/2/2019 16:14'!
asWasm
| s b  i col |
	s := self asNumber asFloat hex.
	b := String new.
col := OrderedCollection new.
	i := 1.
	[b := b
		, (s at: i).
	b:= b
		, (s at: i + 1).
col add: b asHexNumber.
b := String new.
	i < (s size - 1)]
		whileTrue: [i := i + 2].
^col.! !

!String methodsFor: '*WASM' stamp: 'edc 8/25/2017 11:32'!
fill2zero 
	
	
	| result |
	result := self copy .
	[result size < 2] whileTrue:[result := '0' + result ].
	^result! !

!String methodsFor: '*WASM' stamp: 'edc 8/25/2017 10:16'!
fill7zero 
	
	
	| result |
	result := self copy .
	[result size < 7] whileTrue:[result := '0' + result ].
	^result! !

!String methodsFor: '*WASM' stamp: 'edc 1/13/2019 18:26'!
isHexNumber
self do:[:char | ('0123456789ABCDEFabcdef' includes: char) ifFalse:[^false] ].
^true! !

!String methodsFor: '*WASM' stamp: 'edc 6/8/2019 10:21'!
withParentesisCondensed
	"Return a copy of the receiver with leading/trailing blanks removed
	 and consecutive white spaces condensed."

	^String streamContents: [:stream |
		| trimmed  lastBlank|
self last = $) ifFalse:[
		trimmed := self]
ifTrue:[trimmed := self copyFrom: 1 to: self size -1

] .

		lastBlank := true.
		trimmed do: [:c | (c =  $( and: [lastBlank]) ifFalse: [stream nextPut: c].
			lastBlank := c =  $(]].

	" ' abc  d   ' withBlanksCondensed"
! !

!String methodsFor: '*WASM' stamp: 'edc 4/23/2018 08:32'!
withoutAny: char
| s |
	s:= String new.
	self do:[:ch| (ch = char)   ifFalse: [s := s + ch asString]].
	^s
	

! !

!String methodsFor: '*WASM' stamp: 'edc 3/11/2018 07:49'!
withoutParentesis
| s |
	s:= String new.
	self do:[:ch| (ch =  $(  )| (ch =  $))   ifFalse: [s := s + ch asString]].
	^s
	

! !

SimpleButtonMorph subclass: #MemoryCell
	instanceVariableNames: 'section'
	classVariableNames: 'SectionColors WebColors'
	poolDictionaries: ''
	category: 'WASM'!

!MemoryCell class methodsFor: 'initialize-release' stamp: 'edc 9/18/2019 07:25'!
Initialize
"MemoryCell start"
self defineWebColors.
self setSectionColors! !

!MemoryCell class methodsFor: 'as yet unclassified' stamp: 'edc 5/6/2018 05:14'!
defineWebColors
WebColors := Dictionary new.

WebColors at: 'navy'  put:'#001F3F'.
WebColors at: 'blue' put:'#0074D9'.
WebColors at: 'aqua' put:'#7FDBFF'.
WebColors at: 'teal' put:' #39CCCC'.
WebColors at: 'olive'  put:'#3D9970'.
WebColors at: 'green'  put:'#2ECC40'.
WebColors at: 'lime'  put:'#01FF70'.
WebColors at: 'yellow'  put:'#FFDC00'. 
WebColors at: 'orange'  put:'#FF851B'.
WebColors at: 'red'  put:'#FF4136'.
WebColors at: 'fuchsia'  put:'#F012BE'.
WebColors at: 'purple'  put:'#B10DC9'.
WebColors at: 'maroon'  put:'#85144B'.
WebColors at: 'white'  put:'#FFFFFF'.
WebColors at: 'silver'  put:'#DDDDDD'.
WebColors at: 'gray'  put:'#AAAAAA'.
WebColors at: 'black'  put:'#111111'.! !

!MemoryCell class methodsFor: 'initialize-release' stamp: 'edc 5/7/2018 16:18'!
getColor: section 
"MemoryCell getColor: sectionName"
	| color |
	color := SectionColors at: section.
	^ Color
		fromString: (WebColors at: color)! !

!MemoryCell class methodsFor: 'initialize-release' stamp: 'edc 10/4/2019 06:33'!
initialize
"MemoryCell initialize"
self defineWebColors.
self setSectionColors! !

!MemoryCell class methodsFor: 'initialize-release' stamp: 'edc 5/31/2018 14:51'!
setSectionColors
	"MemoryCell setSectionColors"
	| color |
	SectionColors := Dictionary new.
	color := 1.
	#('module' 'type' 'import' 'function' 'table' 'memory' 'export' 'code' 'global' 'start' 'element' 'data' 'custom')
		do: [:section | 
			SectionColors
				at: section
				put: (self webColors keys at: color).
			color := color + 1]! !

!MemoryCell class methodsFor: 'as yet unclassified' stamp: 'edc 5/6/2018 06:09'!
webColors
"MemoryCell webColors"
	^ WebColors! !

!MemoryCell methodsFor: 'event handling' stamp: 'edc 5/6/2018 11:37'!
guess

	self halt! !

!MemoryCell methodsFor: 'initialization' stamp: 'edc 5/7/2018 08:28'!
initialize
	

	self initializeAllButLabel! !

!MemoryCell methodsFor: 'accessing' stamp: 'edc 5/7/2018 16:21'!
label: s
|  newColor oldLabel|
s isNumber ifTrue:[super label: s hex fill2zero asLowercase]
ifFalse:[super label: s].

self
		color: (self class getColor: section).
oldLabel :=(self findA: StringMorph).
newColor := self color diff: Color white.
	newColor > 0.5
		ifTrue: [oldLabel color: Color white]
		ifFalse: [oldLabel color: Color black]. ! !

!MemoryCell methodsFor: 'accessing' stamp: 'edc 5/6/2018 11:14'!
section

	^ section! !

!MemoryCell methodsFor: 'accessing' stamp: 'edc 5/6/2018 11:14'!
section: anObject

	section := anObject! !

!MemoryCell methodsFor: 'initialization' stamp: 'edc 5/7/2018 08:17'!
show: newName 
	| s newColor oldLabel |
	oldLabel := self findA: StringMorph.
	oldLabel
		ifNotNil: [oldLabel delete].
	self
		color: (self class getColor: section).
	s := StringMorph new contents: newName.
	newColor := self color diff: Color white.
	newColor > 0.5
		ifTrue: [s color: Color white]
		ifFalse: [Color black].
	self openInWorld.
	s center: self center.
	self addMorph: s! !

!MemoryCell methodsFor: 'initialization' stamp: 'edc 5/6/2018 11:27'!
show: newName color: thisColor 
	| s newColor  oldLabel  |
	oldLabel :=(self findA: StringMorph).
		oldLabel ifNotNil: [oldLabel delete ].
	self
		color: (self class getColor: thisColor).
	s := StringMorph new contents: newName.
	newColor := self color diff: Color white.
	newColor > 0.5
		ifTrue: [s color: Color white]
		ifFalse: [Color black].
	self openInWorld.
	s center: self center.
	self addMorph: s! !

HVTransientView subclass: #Experiments
	instanceVariableNames: 'page resources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WASM'!

Experiments class
	instanceVariableNames: 'currentPage externalFolder user resources lista colores queMeCuenta'!

!Experiments commentStamp: 'edc 10/15/2019 07:41' prior: 0!
Experiments queMeCuenta: 82
Experiments stop.
Experiments startDebugOn: 8080!

Experiments class
	instanceVariableNames: 'currentPage externalFolder user resources lista colores queMeCuenta'!

!Experiments class methodsFor: 'accessing' stamp: 'edc 1/26/2017 09:28'!
colores
	^ colores
		! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 1/26/2017 09:29'!
colores: aDict 
" Experiments colores: self "
	colores := aDict! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 12/21/2018 10:29'!
createFolderStructure
"Experiments createFolderStructure"
| rootDir|
	self  externalFolder: 'Experiments'.
rootDir := FileDirectory on: self  filePath.
#('css' 'fonts' 'html' 'img' 'js' 'src') do:[:dir| rootDir createDirIfnotExists: dir].! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 2/6/2017 08:27'!
currentPage
"Experiments currentPage"
	^ currentPage! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 2/6/2017 08:28'!
currentPage: aMiHTMLData
	currentPage:= aMiHTMLData! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 12/21/2018 07:26'!
demos
| rootDir|
	"Experiments demos explore"
	 self  externalFolder: 'Experiments/img'.
	rootDir := FileDirectory on: self  filePath.
	
					^rootDir fileNamesMatching: '*.png'.

! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 3/1/2019 08:22'!
demos2
	"Experiments demos2"
	| rootDir img |
	self externalFolder: 'webassemblyExamples/js-api-examples/img'.
	rootDir := FileDirectory on: self filePath.
	^ rootDir fileNamesMatching: '*.png'! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 1/12/2019 07:19'!
externalFolder
	"Transcript show: Experiments externalFolder;cr"
	^ externalFolder
		! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 6/3/2017 12:17'!
externalFolder: aDirName 

	externalFolder := aDirName! !

!Experiments class methodsFor: 'html' stamp: 'edc 1/12/2019 07:10'!
filePath
"Transcript show:  Experiments filePath;cr"
self  externalFolder ifNotNil:[
	^ FileDirectory default pathName , FileDirectory slash , self  externalFolder , FileDirectory slash].
^ FileDirectory default pathName , FileDirectory slash! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 1/14/2017 08:25'!
lista
	"Experiments lista"
	^ lista
		ifNil: [lista := (StandardFileStream readOnlyFileNamed: self filePath + 'txt/CountryList.txt') contents.
			lista := lista findTokens: String lf.
			]! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 3/21/2019 08:54'!
queMeCuenta
	"Experiments queMeCuenta"
	^ queMeCuenta
		ifNil: [queMeCuenta := 1]! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 3/21/2019 08:54'!
queMeCuenta: anIndex 
	"Experiments queMeCuenta: 64"
	queMeCuenta := anIndex! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 1/16/2017 08:40'!
resetlista
	"Experiments resetlista"
	 lista := nil
		! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 1/12/2017 08:07'!
resources
^resources ifNil:[resources := Dictionary new]! !

!Experiments class methodsFor: 'html' stamp: 'edc 10/9/2019 08:18'!
saveImgFromButtons
	"Experiments saveImgFromButtons"
	| lista img |
	self  externalFolder: 'Experiments'.
	lista := #('maze' 'plasma').
	lista
		do: [:nombre | 
			img := (SimpleButtonMorph newWithLabel: nombre) imageForm.
			img writeJPEGfileNamed: self filePath + 'img/' + nombre + '.jpg']! !

!Experiments class methodsFor: 'html' stamp: 'edc 2/6/2019 05:37'!
saveImgFromString: aString 
	"Experiments saveImgFromString:'factorial64.html'"
	| img |
	self externalFolder: 'Experiments'.
	img := (SimpleButtonMorph newWithLabel: aString) imageForm.
	img writePNGfileNamed: self filePath + 'img/' + aString + '.png'! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 2/6/2017 08:51'!
user
^user ifNil:[ 'visita']! !

!Experiments class methodsFor: 'accessing' stamp: 'edc 2/11/2017 09:52'!
user: aUser 
	"Experiments user: 'Edgardec'  "
	user := aUser! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/25/2017 08:03'!
autocomplete
	self class externalFolder: 'Experiments'.
	^ (StandardFileStream readOnlyFileNamed: self filePath + 'txt/countries.html') contents! !

!Experiments methodsFor: 'urls' stamp: 'edc 10/4/2019 20:23'!
br
	self class externalFolder: 'wabt'.
	self page: (StandardFileStream readOnlyFileNamed: self filePath + 'collision.html') contents.
	^ self page! !

!Experiments methodsFor: 'utilities' stamp: 'edc 6/4/2017 11:51'!
buttonImage: url linkTo: link 
	"Embed an image."
	| s |
	s := '<a id="pictureMap"
	href= "' , link , '">' , '<img alt="" ismap="ismap" src="' , url , '">'.
	^ s! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/20/2017 11:02'!
calc
	self class externalFolder: 'Experiments'.
	self page: nil.
	self title:'Calculadora AJAX - Versin PrototypeJS Server Kom'.
	self pageAdd: self htmStart.
	self pageAdd: '<script type="text/javascript" src="' + 'js/prototype.js' + '"></script>'.
	self pageAdd:  (StandardFileStream readOnlyFileNamed: self filePath , '/css/calculadora.css') contents.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'txt/calculadora.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/20/2017 11:58'!
calcular
	| fields operando1 operando2 operador try |
	fields := request fields.
	operando1 := (fields at: 'operando1') first asInteger.
	operando2 := (fields at: 'operando2') first asInteger.
	operador := (fields at: 'operador') first.
	operador caseOf: {
		['SU'] -> [try := operando1 + operando2].
		['RE'] -> [try := operando1 - operando2].
		['MU'] -> [try := operando1 * operando2].
		['DI'] -> [try := operando1 / operando2]}
		 otherwise: [try := 'Operador desconocido'].
	^ try asString! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/7/2017 06:04'!
canvas


	self class externalFolder: nil.
	self page: nil.
self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'canvas2.html') contents.
	^ self pageEnd
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/13/2019 09:11'!
chartjs
	self class externalFolder: 'chartjs'.
	^ (StandardFileStream readOnlyFileNamed:self class filePath +'pie.html')contents! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/4/2017 12:02'!
click
	| fields x y c aPoint this |
	fields := request fields.
	c := fields keys first findTokens: ','.
	x := c first asInteger.
	y := c last asInteger.
	aPoint := Point x: x y: y.
	
	this := World submorphs
				detect: [:m | m containsPoint: aPoint]
				ifNone: [].
				
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/7/2017 13:37'!
codeMirror
	Transcript clear.
	self class externalFolder: 'codeMirror'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd.! !

!Experiments methodsFor: 'urls' stamp: 'edc 10/6/2019 08:03'!
collision
	self class externalFolder: 'maze'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/26/2017 09:51'!
colores
	| fields try resp result |
	fields := request fields.
	self halt.
	try := (fields at: 'colores') first asUppercase.
	result := self class colores
				select: [:any | any beginsWith: try].
	resp := '<ul id="result">'.
	result
		do: [:ea | resp := resp , ' <li onclick="selectCountry(''' , ea , ')"> ' , ea , '</li>'].
	resp := resp , '</ul>'.
	^ resp! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/26/2017 09:45'!
coloresBegin
	self class externalFolder: 'Experiments'.
	self page: nil.
	self title: 'Selector a AJAX - Versin PrototypeJS Server Kom'.
	self pageAdd: self htmStart.
	self pageAdd: '<script type="text/javascript" src="' + 'js/prototype.js' + '"></script>'.
	 self pageAdd:(StandardFileStream readOnlyFileNamed: self filePath + 'txt/colores.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/11/2017 09:27'!
compile
| fields try resp |
	fields := request fields.
	try := (fields at: 'value') first.
	resp := Compiler evaluate: try.
	^resp
! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/14/2019 10:43'!
consoleLog
^(StandardFileStream readOnlyFileNamed: self class filePath + 'consoleLog.html') contents.! !

!Experiments methodsFor: 'resume' stamp: 'edc 12/19/2018 09:07'!
createAnchor
	self halt! !

!Experiments methodsFor: 'resume' stamp: 'edc 1/8/2019 07:05'!
createElementSample
'<!!DOCTYPE html>
<html>
<body>

<div id="div1">
<p id="p1">This is a paragraph.</p>
<p id="p2">This is another paragraph.</p>
</div>

<script>
var para = document.createElement("p");
var node = document.createTextNode("This is new.");
para.appendChild(node);
var element = document.getElementById("div1");
element.appendChild(para);
</script>

</body>
</html>
'! !

!Experiments methodsFor: 'resume' stamp: 'edc 12/19/2018 09:05'!
createExperienceItem
	self halt! !

!Experiments methodsFor: 'resume' stamp: 'edc 1/9/2019 08:51'!
createHeader
	^'<header><h1>Jay Phelps</h1><div>hello@jayphelps.com - Knoxville, TN</div><p>Reactive Programming expert, compiler enthusiast, open source contributor, and speaker. WebAssembly Community Group member. Google Developer Expert. Author of core-decorators, co-author of redux-observable, and RxJS core team alum.</p></header>'! !

!Experiments methodsFor: 'resume' stamp: 'edc 1/9/2019 09:02'!
createResume
	^'<div class="resume"><div class="resume-left-column"><header><h1>Jay Phelps</h1><div>hello@jayphelps.com - Knoxville, TN</div><p>Reactive Programming expert, compiler enthusiast, open source contributor, and speaker. WebAssembly Community Group member. Google Developer Expert. Author of core-decorators, co-author of redux-observable, and RxJS core team alum.</p></header><section><h2>Experience</h2><ol><li><h3 class="job-company">This Dot, Inc.</h3><div class="job-title">Co-founder</div><div class="job-date">June 2017 (part-time) - Feb 2018 (full-time) - Dec 2018</div><p class="job-desc">Led the architecture of client projects in various languages and domains. Helped with Developer Relations and strategy for clients. Mentoring for engineers of clients, employees, and subcontractors.      </p></li><li><h3 class="job-company">Netflix, Inc.</h3><div class="job-title">Senior Software Engineer</div><div class="job-date">Jan 2015 - Feb 2018</div><p class="job-desc">Developer Experience. Build internal applications, frameworks, and libraries with a focus on real-time debugging. Helped in the rewrite of RxJS v5 with a focus on performance, better debuggability, and bundle sizes. Supported developers across Netflix in RxJS.</p></li><li><h3 class="job-company">Pivotshare, Inc.</h3><div class="job-title">Chief Technology Officer</div><div class="job-date">May 2013 - Jan 2015</div><p class="job-desc">Engineering lead and individual contributor for a video-on-demand platform; think "Netflix platform as a service".</p></li><li><h3 class="job-company">SignNow, acquired by Barracuda Networks</h3><div class="job-title">Lead Front End Engineer</div><div class="job-date">Oct 2011 - May 2013</div><p class="job-desc">Led the development of our e-signing web app in JavaScript. Created PDF manipulation utilities (written in C++) that solved performance issues with our previous PHP-based solutions. Also created Objective-C++ bindings for it that were utilized in our iOS app for offline capability. </p></li><li><h3 class="job-company">XOWii, acquired by Evolv Health</h3><div class="job-title">Lead Developer</div><div class="job-date">Dec 2009 - Oct 2011</div><p class="job-desc"></p></li></ol><div class="previous-employment">Previous employment available upon request</div>'! !

!Experiments methodsFor: 'resume' stamp: 'edc 1/9/2019 09:01'!
createSocialItem
	^'<section><h2>Social</h2><ol><li><div>Twitter: <a href="https://twitter.com/_jayphelps">@_jayphelps</a></div></li><li><div>GitHub: <a href="https://github.com/jayphelps">@jayphelps</a></div></li><li><div>Stack Overflow: <a href="https://stackoverflow.com/users/1770633/jayphelps">@jayphelps</a></div></li><li><div>Medium: <a href="https://medium.com/@jayphelps">@jayphelps</a></div></li></ol></section></div></div>'! !

!Experiments methodsFor: 'resume' stamp: 'edc 1/9/2019 09:04'!
createTalkItem
	^'</div><div class="resume-right-column"><section><h2>Talks</h2><ol><li><div>WebAssembly Demystified</div><div><a href="https://goo.gl/NBEvmp">https://goo.gl/NBEvmp</a></div></li><li><div>RxJS + Redux + React = Amazing!!</div><div><a href="https://goo.gl/fy89o7">https://goo.gl/fy89o7</a></div></li><li><div>Real-time Insights Powered by Reactive Programming</div><div><a href="https://goo.gl/C7xvyv">https://goo.gl/C7xvyv</a></div></li></ol></section>'! !

!Experiments methodsFor: 'resume' stamp: 'edc 1/9/2019 08:45'!
createWasmBanner



" (func $createWasmBanner (result i32)
    (local $div i32)
    (call $Object::set
      (tee_local $div
        (call $document.createElement
          (get_global $divString)
        )
      )
      (get_global $innerTextString)
      (get_global $wasmBannerText)
    )
    (call $Object::set
      (get_local $div)
      (get_global $classNameString)
      (get_global $wasmBannerClassNameString)
    )
    (call $Element::appendChild
      (get_local $div)
      (call $createAnchor
        (get_global $sourceCodeUrlText)
        (get_global $viewItHereText)
      )
    )
    (get_local $div)
  )"
	^'<div class="wasm-banner">This page was generated using hand-written WebAssembly text just for kicks. <a href="https://github.com/jayphelps/_/blob/gh-pages/main.wat">View it here.</a></div>'! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/15/2019 07:09'!
debugMe
	| fields |
	fields := request fields.
	self halt.
! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/12/2019 07:31'!
default
	self class externalFolder: 'Experiments'.
	^ '<!!doctype html>
<head>
<title>ChanchoWasm</title>
</head>
<body>
	
			<img src="pictures/ChanchoWasm.png" >
</body>
</html>'! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/14/2019 10:19'!
demos
	| lista |
	self class externalFolder: 'Experiments'.
	self page: nil.
	self pageAdd: self htmStart.
	self pageAdd: '<body>'.
	lista := self class demos.
	self pageAdd: '<div class="list-output">
          <ul>'.
	lista
		do: [:nombre | self
				pageAdd: (self buttonImage: nombre asString linkTo: '/demosExecute:' , nombre)].
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/14/2019 10:48'!
demos2
	| lista |
	self class externalFolder: 'webassemblyExamples/js-api-examples/img'.
	self page: nil.
	self pageAdd: self htmStart.
	self pageAdd: '<body>'.
	lista := self class demos2.
	self pageAdd: '<div class="list-output">
          <ul>'.
	lista
		do: [:nombre | self
				pageAdd: (self buttonImage: nombre asString linkTo: '/demos2Execute:' , nombre)].
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/14/2019 10:51'!
demos2Execute: fileName 
	| htmlName |
	self class externalFolder: 'webassemblyExamples/js-api-examples/'.
	htmlName := (fileName splitBy: '.png') first.
	self page: (StandardFileStream readOnlyFileNamed: self class filePath + htmlName) contents.
	self pageAdd: self consoleLog.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/14/2019 10:18'!
demosExecute: fileName 
	| htmlName |
	self class externalFolder: 'wabt'.
	htmlName := (fileName splitBy: '.png') first.
	self page: (StandardFileStream readOnlyFileNamed: self class filePath + htmlName) contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 10/16/2019 09:16'!
dispatchOn: method 
	"Dispatch to correct method:
	- If method is empty we call #default
	- If the selector is allowed to be executed then
	we just call it
	- If method is prefixed with 'src' and viewing the
	source is allowed,
	then we return a HTML page with the source for
	that method."
	| m split couldExec p filePath dir |
	Transcript show: method;
		 tab.
	method isEmptyOrNil
		ifTrue: [^ self default].
	m := method asSymbol.
	(self allowedSelector: m)
		ifTrue: [^ self perform: m].
	split := method splitBy: ':'.
	couldExec := (split first , ':') asSymbol.
	(self allowedSelector: couldExec)
		ifTrue: [self class externalFolder: nil.
			^ self perform: couldExec with: split last withBlanksCondensed]
		ifFalse: [p := self urlStream url path.
			dir := FileDirectory default.
			filePath := dir pathName.
			self class externalFolder
				ifNotNil: [filePath := filePath , FileDirectory slash , self class externalFolder].
			p
				do: [:ea | filePath := filePath , FileDirectory slash , ea].
			(dir fileExists: filePath)
				ifTrue: [(filePath endsWith: 'wasm')
						ifTrue: [self response contentType: 'application/wasm'].
					(filePath endsWith: 'js')
						ifTrue: [self response contentType: 'application/javascript'].
					Transcript show: self response contentType;show:String cr.
					^ StandardFileStream readOnlyFileNamed: filePath]
				ifFalse: [Transcript show: 'This path ' , '<h3>' , filePath , '</h3>' , 'is unimplemented';
						 cr.
					^ 'This path ' , '<h3>' , filePath , '</h3>' , 'is unimplemented']]! !

!Experiments methodsFor: 'html' stamp: 'edc 12/19/2018 09:48'!
divString: aString 
	self pageAdd: '<div>' , aString , '</div>'! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/4/2017 07:21'!
echo
	| fields |
	fields := request fields.
	fields explore.
	self halt! !

!Experiments methodsFor: 'urls' stamp: 'edc 12/20/2018 15:56'!
ex
	| rootDir aList img|
	self class externalFolder: 'wabt'.
	rootDir := FileDirectory on: self class filePath.
	
					aList := rootDir fileNamesMatching: '*.html'.
aList do:[:aString|
self class demos add: aString.
	self class externalFolder: 'Experiments'.
	img := (SimpleButtonMorph newWithLabel: aString) imageForm.
	img writePNGfileNamed: self filePath + 'img/' + aString + '.png'].! !

!Experiments methodsFor: 'urls' stamp: 'edc 12/20/2018 15:31'!
ex2
	| todo rootDir thisDir path thisName aList |
	self class externalFolder: 'webassemblyExamples2'.
	rootDir := FileDirectory on: self class filePath.
	path := rootDir pathName.
	todo := rootDir directoryNames asOrderedCollection.
	[todo isEmpty]
		whileFalse: [thisName := todo removeFirst.
			Transcript show: thisName;
				 cr.
			Transcript show: '======>'.
			thisDir := FileDirectory on: path , FileDirectory slash , thisName.
			thisDir
				withAllSubdirectoriesCollect: [:subDir | 
					self halt.
					aList := subDir fileNamesMatching: '*.js']]! !

!Experiments methodsFor: 'urls' stamp: 'edc 12/21/2018 07:22'!
execute: fileName
|htmlName|
self class externalFolder: 'wabt'.
htmlName := (fileName splitBy:'.png') first.
self page:(StandardFileStream readOnlyFileNamed: self class filePath + htmlName) contents.
^self pageEnd
! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/8/2017 10:07'!
fabric
	Transcript clear.
	self class externalFolder: 'fabric'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/7/2017 14:16'!
famousengine
	Transcript clear.
	self class externalFolder: 'famousengine'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd.! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/14/2019 16:39'!
fibonacci
	self class externalFolder: 'D3'.
	self page: (StandardFileStream readOnlyFileNamed: self filePath +'fib.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'accessing' stamp: 'edc 12/10/2016 07:47'!
filePath
	^ FileDirectory default pathName , FileDirectory slash , self class externalFolder  , FileDirectory slash.! !

!Experiments methodsFor: 'urls' stamp: 'edc 4/21/2018 06:36'!
gitreveal
	self redirectTo:'http://github.com/hakimel/reveal.js/'! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/10/2017 08:35'!
gmaps
	Transcript clear.
	self class externalFolder: '/gmaps/examples'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'examples.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'html' stamp: 'edc 12/9/2016 17:27'!
h1: aString
	self pageAdd: '<h1>' , aString , '</h1>'.! !

!Experiments methodsFor: 'html' stamp: 'edc 12/9/2016 17:28'!
h2: aString
	self pageAdd: '<h2>' , aString , '</h2>'.! !

!Experiments methodsFor: 'html' stamp: 'edc 12/9/2016 17:28'!
h3: aString
	self pageAdd: '<h2>' , aString , '</h3>'.! !

!Experiments methodsFor: 'html' stamp: 'edc 2/11/2017 08:58'!
head
	^ '<!!DOCTYPE html>

<!!--[if lt IE 8 ]><html class="no-js ie ie7" lang="en"> <!![endif]-->

<!!--[if IE 8 ]><html class="no-js ie ie8" lang="en"> <!![endif]-->

<!!--[if IE 9 ]><html class="no-js ie ie9" lang="en"> <!![endif]-->

<!!--[if (gte IE 8)|!!(IE)]><!!--><html class="no-js" lang="en"> <!!--<!![endif]-->

<head>



   <!!--- Basic Page Needs

   ================================================== -->

   <meta charset="utf-8">

	<title>Bar y Cafe SqueakRos, refugio de viejos programadores.</title>

	<meta name="description" content="">  

	<meta name="author" content="">



	<!!-- mobile specific metas

   ================================================== -->

	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">



   <!!-- CSS

    ================================================== -->

   <link rel="stylesheet" href="css/default.css">

	<link rel="stylesheet" href="css/layout.css">  

	<link rel="stylesheet" href="css/media-queries.css">    



   <!!-- Script

   ================================================== -->

	<script src="js/modernizr.js"></script>



   <!!-- Favicons

	================================================== -->

	<link rel="shortcut icon" href="favicon.png" >
    <style type="text/css">
    body{
        margin:0px;
        background:#000;
    }
    .header-cont {
        width:100%;
        position:fixed;
        top:0px;
	FONT-WEIGHT: bold;
	FONT-SIZE: x-large;
	BACKGROUND: navy;
	BORDER-LEFT: #fff 1px solid;
	COLOR: #fff;
	FONT-FAMILY: georgia, verdana, arial, sans-serif

}
    }
    .header {
        height:50px;
        background:#F0F0F0;
        border:1px solid #CCC;
        width:960px;
        margin:0px auto;
    }
    .content {
        width:960px;
        background: #F0F0F0;
        border: 1px solid #CCC;
        height: 2000px;
        margin: 70px auto;
    }
    </style>
    </head>
    <body>'! !

!Experiments methodsFor: 'html' stamp: 'edc 12/20/2018 16:05'!
htmStart
	^ '<!!doctype html>
<html>
<head>
    <meta charset="utf-8">
<title>WASM test</title>
</head>'! !

!Experiments methodsFor: 'html' stamp: 'edc 12/9/2016 17:35'!
img: aString style: aStyle
	self pageAdd: '<img src= img/' , aString , ' style=" ' , aStyle , '  ;">  ''
	
	
'.! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/7/2017 13:02'!
interact
	Transcript clear.
	self class externalFolder: 'interact'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd.! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/4/2017 12:44'!
leaflet
	Transcript clear.
	self class externalFolder: 'leaflet'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd.! !

!Experiments methodsFor: 'urls' stamp: 'edc 12/10/2016 18:07'!
listaSuper
	| f colorsWEB items count tc thisColor |
	colorsWEB _ #(#blue #aqua #teal #olive #green #lime #yellow #orange #red #fuchsia #purple #maroon #white #silver #gray ).
	self class externalFolder: 'CompraSuper'.
	self page: nil.
	self pageAdd: self htmStart.
	self pageAdd: '<link rel="stylesheet" href="css/ModernWebColors.css">'.
	f _ (StandardFileStream readOnlyFileNamed: 'ListaSupeComestiblesr.txt') contents.
	f _ f splitBy: String lf.
	items _ f size // 14.
	count _ 0.
	tc _ 1.
	self pageAdd: self superCss.
	self pageAdd: '<h1>' , f first , '</h1>
	<form method="post" action = "/printSuper">'.
	2
		to: f size
		do: [ :index |
			count _ count + 1.
			thisColor _ (colorsWEB at: tc) asString.
			count = 1 ifTrue: [ self pageAdd: '<div class = "' , 'bg-' , thisColor , '">' ].
			self pageAdd: '<li><input type="checkbox"     name="' , (f at: index) , '"/>' , (f at: index) , '</li>'.
			count = items ifTrue: [
				count _ 0.
				tc _ tc + 1.
				self pageAdd: '</div>' ]].
	self pageAdd: '<input type="submit"  value="Submit" />
	</div>
</form>'.
	^ self pageEnd.! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/8/2017 09:16'!
livesearch
	self class externalFolder: 'Autocomplete'.
	self page: nil.
	 self pageAdd: self htmStart.
	self pageAdd: '<script type="text/javascript" src="' + 'prototype.js' + '"></script>'.
	self pageAdd: '<script type="text/javascript" src="autocomplete.js"></script>'.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'autocomplete.5.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 2/9/2017 08:13'!
loremipsum
	^ '<p class="lead"<p>  Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Maecenas enim. Nulla facilisi. Vestibulum accumsan augue vulputate justo. Fusce faucibus. Sed blandit, neque sed lacinia nonummy, diam quam imperdiet justo, at dictum augue nunc a neque. Sed urna lacus, tincidunt at, aliquam id, fringilla id, felis. Vivamus feugiat molestie quam. Sed id dolor. Sed ac purus id sapien sollicitudin ultricies. Aliquam hendrerit orci et odio. Suspendisse volutpat wisi at sem. Integer eget nulla. Duis eu diam a nunc condimentum tempus. Praesent gravida metus vitae massa. Aliquam neque magna, fringilla eu, porta id, interdum sit amet, dui. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Proin lorem est, ultrices sit amet, condimentum vitae, vehicula a, massa </p>.'! !

!Experiments methodsFor: 'urls' stamp: 'edc 10/6/2019 08:06'!
maze
	self class externalFolder: 'maze'.
	self page: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self page! !

!Experiments methodsFor: 'urls' stamp: 'edc 10/16/2019 08:56'!
memory
	self class externalFolder: 'wabt'.
	self page: (StandardFileStream readOnlyFileNamed: self filePath + 'memory1.html') contents.
	^ self page! !

!Experiments methodsFor: 'css' stamp: 'edc 12/8/2016 08:44'!
modernWebColors

	^ (StandardFileStream readOnlyFileNamed:self filePath, '/css/ModernWebColors.css') contents! !

!Experiments methodsFor: 'html' stamp: 'edc 2/11/2017 10:54'!
nav
	^ '<body>
  <!!-- Header  ================================================== -->

   <header id="top">
	<div class="row">
		<div class="header-content twelve columns">
			 <h1 id="logo-text"><a href="index.html" title="">Bar SqueakRos</a></h1>
					<p id="intro">Lasciate ogne speranza, voi chi intrate.</p>
		</div>			
		</div>

   <nav id="nav-wrap"> 
	<a class="mobile-btn" href="#nav-wrap" title="Show navigation">Show Menu</a>
   <a class="mobile-btn" href="#" title="Hide navigation">Hide Menu</a>
		<div class="row">    		            
			<ul id="nav" class="nav">
  				<li><a class="navbar-brand" href="welcome">Bar SqueakRos</a></li>
				

		<li class="dropdown"><a class="dropdown-toggle" data-toggle="dropdown" href="#">What Change ? <span class="caret"></span></a>
              <ul class="dropdown-menu">
			<li class="active"><a href="news">see Last Week</a></li>
			<li class="active"><a href="lastPost">see Last Chronicle</a></li>
			<li class="active"><a href="lastPage">see Last Wiki Page</a></li>
 			</ul>
            </li>
		<li class="dropdown"><a class="dropdown-toggle" data-toggle="dropdown" href="#">UserActions <span class="caret"></span></a>
              <ul class="dropdown-menu">
               <li><a href="newPage">newPage</a></li>
<li><a href="newPost">newPost</a></li>
<li><a href="edit">Edit</a></li>
<li><a href="deletePage">deletePage</a></li>
              </ul>
            </li>
<li class="dropdown"><a class="dropdown-toggle" data-toggle="dropdown" href="#">Archives <span class="caret"></span></a>
              <ul class="dropdown-menu">
               <li><a href="showWikiLastYear">Post of last year</a></li>
<li><a href="showWikiLastMonth">Post of last month</a></li>
<li><a href="edit">Edit</a></li>
<li><a href="deletePage">deletePage</a></li>
              </ul>
            </li> 
  </nav> <!!-- end #nav-wrap --> 	     
 </header> <!!-- Header End -->
 '! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/14/2019 16:58'!
nbody
	self class externalFolder: 'D3'.
	self page: (StandardFileStream readOnlyFileNamed: self filePath + 'nbody.html') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/3/2017 12:16'!
olddemos
	| lista |
	self class externalFolder: 'CompraSuper'.
	self page: nil.
	self pageAdd: self htmStart.
	self pageAdd: '</head>
	<body>'.
	self title: 'El @morplenauta Lo Hizo'.
	lista _ #('Lista Super' 'ToDo List' 'Smalltalk' ).
	self pageAdd: '<div class="list-output">
          <ul>'.
	lista do: [ :nombre |
		self pageAdd:
			(self
				buttonImage: 'img/' +nombre + '.jpg'
				linkTo: 'osooo') ].
	self pageAdd: ' </ul>'.
	^ self pageEnd.! !

!Experiments methodsFor: 'accessing' stamp: 'edc 12/7/2016 08:17'!
page
	^ page ifNil: [ page _  String new].! !

!Experiments methodsFor: 'accessing' stamp: 'edc 12/7/2016 08:18'!
page: anObject

	page := anObject! !

!Experiments methodsFor: 'accessing' stamp: 'edc 12/9/2016 08:49'!
pageAdd: aString
	 page:= self page,aString,String lf! !

!Experiments methodsFor: 'html' stamp: 'edc 2/10/2017 20:31'!
pageContent: aMiHTMLData 
	^ ' <!!-- Content

   ================================================== -->

   <div id="content-wrap">



   	<div class="row">



   		<div id="main" class="eight columns">



	   		<article class="entry">



					<header class="entry-header">



						<h2 class="entry-title">

							<a href="single.html" title="">' + aMiHTMLData title + '</a>

						</h2> 				 

					

						<div class="entry-meta">

							<ul>

								<li>' + aMiHTMLData date + '</li>

								<span class="meta-sep">&bull;</span>								

								<li><a href="#" title="" rel="category tag">Ghost</a></li>

								<span class="meta-sep">&bull;</span>

								<li>' + aMiHTMLData author + '</li>

							</ul>

						</div> 

					 

					</header> 

					

					<div class="entry-content">

						' + aMiHTMLData body + '

					</div> 



				</article> <!!-- end entry -->
'! !

!Experiments methodsFor: 'html' stamp: 'edc 1/8/2019 07:12'!
pageEnd
	self pageAdd: '</body> 
	</html> '.
	^ self page
! !

!Experiments methodsFor: 'urls' stamp: 'edc 3/21/2019 08:48'!
queMeCuenta
| l |
	l := LedMorph new.
	l value: self class queMeCuenta.
	l extent: 120 @ 40.
	^ l imageForm! !

!Experiments methodsFor: 'utilities' stamp: 'edc 2/1/2017 08:47'!
randomImg
	^ 'http://www.squeakros.org/Divagaciones/img/' , #('AutitoMecano.gif' 'Byron8meses.jpg' 'CasaDeMisSueɬos.jpg' 'CatsClubBallooning.jpg' 'Colin and Edgar.jpg' 'DonUri.jpg' 'EdgarElMorplenauta.jpg' 'Edgar_8144.jpg' 'EdgarconDanIngalls.2.jpg' 'Nastya2meses.jpg' 'R8.jpg' 'ScarlettJohansson2.jpg' 'yo.JPG' 'fangio_ger_57.gif') atRandom! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/8/2017 09:40'!
readColores
	| fields try resp result |
	fields := request fields.
	try := (fields at: 'colores') first asUppercase.
	result := self class colores
				select: [:any | any beginsWith: try].
	resp := '<ul id="result">'.
	result
		do: [:ea | resp := resp , ' <li onclick="selectCountry(''' , ea , ')"> ' , ea , '</li>'].
	resp := resp , '</ul>'.
	^ resp! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/9/2017 05:37'!
readCountry
	| fields try resp result |
	fields := request fields.

	try := (fields at: 'keyword') first asUppercase.
	result := self class lista
				select: [:any | any beginsWith: try].
	resp := '<ul id="country-list">'.
	result
		do: [:ea | resp := resp , ' <li onclick="selectCountry(''' , ea , ')"> ' , ea , '</li>'].
	resp := resp , '</ul>'.
	^ resp! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/26/2017 10:34'!
readZip
	| fields try resp result s |
	fields := request fields.
	try := fields at: 'zip'.
	result := Codigos cp: try.
	resp := '<ul id="zipResultt">'.
	result
		do: [:ea | 
			s := String new.
			ea
				do: [:field | s := s , field , String tab].
			resp := resp , ' <li onclick="select(''' , s , ')"> ' , s , '</li>'].
	resp := resp , '</ul>'.
	^ resp! !

!Experiments methodsFor: 'accessing' stamp: 'edc 12/7/2016 08:21'!
resources
^(PackageInfo named:  'HV-Divagaciones')  resources
! !

!Experiments methodsFor: 'urls' stamp: 'edc 12/19/2018 09:56'!
resume
	Transcript clear.
self class externalFolder: 'truresume'.
	self page: (StandardFileStream readOnlyFileNamed: self filePath + 'beginResume.html') contents.
	self createWasmBanner.
	
	^ self pageEnd! !

!Experiments methodsFor: 'css' stamp: 'edc 1/9/2019 08:39'!
resumeCss

	^ ' <style>
body {
      background: white;
      margin: 0;
    }

    noscript,
    #error {
      color: red;
      font-size: 18px;
      font-weight: bold;
      text-align: center;
      white-space: pre;
    }

    #error {
      padding: 100px;
      display: none;
    }

    .wasm-banner {
      background-color: #ffeec8;
      padding: 10px;
      border-bottom: 2px solid #efd293;
      color: #9e6d00;
    }

    .resume {
      display: flex;
      flex-wrap: wrap;
      font-family: ''Roboto'', sans-serif;
      font-size: 12px;
    }

    h1 {
      margin-top: 0;
      margin-bottom: 3px;
    }

    .resume-left-column,
    .resume-right-column {
      margin: 20px;
    }

    .resume-left-column {
      flex-grow: 1;
      max-width: 600px;
    }

    .resume-right-column {
      min-width: 260px;
    }

    .job-company {
      margin-bottom: 3px;
    }

    .job-title {
      font-style: italic;
      margin-bottom: 5px;
    }

    .job-dates {
      font-size: 0.8em;
    }

    .previous-employment {
      color: gray;
    }

    @media print {
      .wasm-banner {
        display: none;
      }

      .resume {
        flex-wrap: nowrap;
      }

      a {
        text-decoration: none;
        color: black;
      }
    }
 </style>
'! !

!Experiments methodsFor: 'urls' stamp: 'edc 4/21/2018 06:51'!
reveal
	Transcript clear.
	self class externalFolder: 'reveal.js-master'.
	^StandardFileStream readOnlyFileNamed: self filePath , 'demo.html'.
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/4/2017 06:24'!
s8
Transcript clear.

	self class externalFolder: 'public'.
	self page: nil.
self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/12/2017 10:12'!
scriptaculous
	self class externalFolder: 'scriptaculous'.
	self page: nil.
	self pageAdd: self htmStart.
	self pageAdd: '<script type="text/javascript" src="' + 'js/prototype.js' + '"></script>'.
	self pageAdd: '<script type="text/javascript" src="' + 'js/scriptaculous.js ' + '"></script>'.
	self pageAdd: '<script type="text/javascript" src="' + 'js/unittest.js ' + '"></script>'.
	self pageAdd: '</head>'.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'functional/effects_grow_strink_test.txt') contents.
	^ self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/9/2019 07:43'!
site
	Transcript clear.
	self class externalFolder: 'site'.
	self page: nil.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd.! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/11/2017 15:50'!
smalltalk
	| path |
	self class externalFolder: 'scriptaculous/test/functional'.
	path :=self filePath.
	^ (StandardFileStream readOnlyFileNamed: path , 'dragwindow.html') contents
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/8/2017 09:08'!
teach


	self class externalFolder: nil.
	self page: nil.
self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'DescubriendoSqueak2.html') contents.
	^ self pageEnd
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/9/2019 09:00'!
test
self page: self htmStart.
self pageAdd:self resumeCss.
self pageAdd:self createWasmBanner.
self pageAdd:self createHeader.
self pageAdd:self createResume.
self pageAdd:self createTalkItem.
self pageAdd:self createSocialItem.
^self pageEnd! !

!Experiments methodsFor: 'urls' stamp: 'edc 10/5/2019 04:57'!
tim
	self class externalFolder: 'tim'.
	self page: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self page! !

!Experiments methodsFor: 'urls' stamp: 'edc 4/29/2019 07:30'!
version
| l |
	l := LedMorph new.
	l value: self class queMeCuenta.
	l extent: 120 @ 40.
	^ l imageForm! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/3/2017 12:22'!
wassembler
Transcript clear.

	self class externalFolder: 'wassembler'.
	self page: nil.
self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'index.html') contents.
	^ self pageEnd
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 6/4/2017 11:58'!
webWorld
^self
		buttonImage: '/world'
		linkTo: 'click'
	! !

!Experiments methodsFor: 'urls' stamp: 'edc 12/8/2016 05:10'!
world
	^ World imageForm ! !

!Experiments methodsFor: 'urls' stamp: 'edc 1/26/2017 10:08'!
zipBegin
self class externalFolder: 'Experiments'.
	self page: nil.
	self pageAdd: '<html>
<head>

<script src="js/prototype.js" language="JavaScript" type="text/javascript"></script>'.
	self pageAdd: (StandardFileStream readOnlyFileNamed: self filePath + 'txt/zip.html') contents.
	^ self pageEnd! !

!Float methodsFor: '*WASM' stamp: 'edc 5/21/2019 11:13'!
f32
| val t1 t2 t3 t4 t5 t6 t7 t8 swap4Bytes1 swap4Bytes2   p1 p2 p3 p4 result|

"// Swap 4 byte, 32 bit values:

	#define Swap4Bytes(val) \

	 ( (((val) >> 24) & 0x000000FF) | (((val) >>  8) & 0x0000FF00) | 
	   (((val) <<  8) & 0x00FF0000) | (((val) << 24) & 0xFF000000) )
"
val := self asIEEE32BitWord.
t1 := val >> 24.
t2 := 255."0x000000FF"
p1 := t1 bitAnd: t2.

t3 := val >>  8.
t4 := 65280. "0x0000FF00"
p2 := t3 bitAnd: t4.
t5:= val <<  8.

 t6:= 16711680."0x00FF0000"
p3 := t5 bitAnd: t6.
t7 := val << 24.

t8 :=  4278190080."0xFF000000"
p4 := t7 bitAnd: t8.
swap4Bytes1 := p1 bitOr: p2 .
swap4Bytes2 :=  p3 bitOr:p4.
result := swap4Bytes1 bitOr:swap4Bytes2.
^result
! !

!Float methodsFor: '*WASM' stamp: 'edc 6/9/2019 09:46'!
f64
|b|
b := ByteArray new:8.
b doubleAt: 1 put: self  bigEndian: false.
^b
! !

Object subclass: #Calculator
	instanceVariableNames: 'tape display'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WASM'!

!Calculator commentStamp: 'edc 5/6/2019 06:50' prior: 0!
Calculator new


!

!Calculator methodsFor: 'actions' stamp: 'edc 5/6/2019 06:54'!
addToTape: aSimpleButtonMorph 
	| aString |
	aString := String new.
	self tape add: aSimpleButtonMorph label.
	aSimpleButtonMorph label = 'CLEAR'
		ifTrue: [self tape: OrderedCollection new.
			display delete].
	tape
		do: [:ea | ea isAllDigits
				ifTrue: [aString := aString , ea]
				ifFalse: [ea = 'ENTER'
						ifTrue: [aString := aString , ' ']
						ifFalse: [aString := aString , ' ' , ea , ' ']]].
	aSimpleButtonMorph label = '='
		ifTrue: [WasmLogger open.self wasmi: aString]
		ifFalse: [self displayString: aString]! !

!Calculator methodsFor: 'accessing' stamp: 'edc 5/4/2019 19:32'!
display

	^ display! !

!Calculator methodsFor: 'accessing' stamp: 'edc 5/4/2019 19:32'!
display: anObject

	display := anObject! !

!Calculator methodsFor: 'initialize-release' stamp: 'edc 5/5/2019 09:31'!
displayString: aString 
	| m |
	m := self display submorphs first.
	m := m findA: StringMorph.
	m contents: aString.
	self display width: m width +10! !

!Calculator methodsFor: 'initialize-release' stamp: 'edc 5/5/2019 09:29'!
initialize
	| x y b args s |
	x := 50.
	y := 50.
	0
		to: 9
		do: [:i | 
			b := SimpleButtonMorph new target: self.
			b label: i asString.
			args := Array with: b.
			b actionSelector: #addToTape:.
			b arguments: args.
			b position: x @ y.
			b openInWorld.
			x := x + b width + 10.
			i \\\ 3 = 0
				ifTrue: [x := 50.
					y := y + b height + 10]].
	#('+' '-' '/' '*' '=' 'CLEAR' 'ENTER' )
		do: [:i | 
			b := SimpleButtonMorph new target: self.
			b label: i asString.
			b actionSelector: #addToTape:.
			b arguments: {b}.
			b position: x @ y.
			b openInWorld.
			x := x + b width + 10].
	s := StringMorph contents: '         ' font: TextStyle defaultFont.
	self display: (AlignmentMorphBob1 new borderWidth: 4;
			 borderColor: Color black;
			 color: Color white).
	self display addARow: {s}.
	self display position: 50 @ 240.
	display openInWorld! !

!Calculator methodsFor: 'accessing' stamp: 'edc 5/4/2019 11:21'!
tape

	^ tape ifNil:[tape := OrderedCollection new]! !

!Calculator methodsFor: 'accessing' stamp: 'edc 5/4/2019 11:20'!
tape: anObject

	tape := anObject! !

!Calculator methodsFor: 'actions' stamp: 'edc 5/4/2019 19:28'!
wasmi
self halt.! !

!Calculator methodsFor: 'actions' stamp: 'edc 5/6/2019 07:12'!
wasmi: aString 
	| instructions code calc const t f val w|
	calc := #(0 97 115 109 1 0 0 0 1 5 1 96 0 1 127 3 2 1 0 7 5 1 1 120 0 0 10 ).
	calc := calc asOrderedCollection.
	instructions := aString findTokens: ' '.
	code := OrderedCollection new.
	instructions
		do: [:ea | ea isAllDigits
				ifTrue: [const := ea asInteger.
					code add: 65.
					code := code
								, (LEB128 encodeUnsignedLEB: const)]
				ifFalse: [ea caseOf: {
						['+'] -> [code add: 106].
						['-'] -> [].
						['/'] -> [].
						['\'] -> [].
						['='] -> [code add: 11]}]].
	
	code addFirst: 0.
t := code size.
	code addFirst: t.
	code addFirst: 1.
	code addFirst: code size.
	calc := calc , code.
	f := (FileStream forceNewFileNamed: 'calcula..wasm') binary.
	1
		to: calc size
		do: [:i | 
			val := calc at: i.
			val
				ifNotNil: [f nextPut: val]].
	f close.
w :=WasmForensics new .
w wasm: calc.
w processWasm
! !

Object subclass: #LEB128
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WASM'!

!LEB128 class methodsFor: 'as yet unclassified' stamp: 'edc 2/25/2019 14:34'!
encodeUnsignedLEB: v 
	| value byte out |
	value := v.
	out := OrderedCollection new.
	[byte := value bitAnd: 127.
	value := value >> 7.
	value > 0
		ifTrue: [byte := byte bitOr: 128].
out add: byte.
	value > 0]
		whileTrue.
	^ out! !

!LEB128 class methodsFor: 'as yet unclassified' stamp: 'edc 5/21/2019 07:25'!
f32Test
	
	
	"LEB128 f32Test
http://jsfromhell.com/classes/binary-parser/example
	2	00 00 00 40
	50	00 00 48 42
	160	00 00 20 43
	40	00 00 20 42
	100	00 00 c8 42
	4	00 00 80 40
	1.2	9a 99 99 3f
	50	00 00 48 42
	160	00 00 20 43
	3	00 00 40 40
	0.1	cd cc cc 3d
	0.15	9a 99 19 3e"
	#('2' '50' '160' '40' '100' '4' '1.2' '3' '0.1' '0.15' )
		do: [:ea | Transcript show: ea asNumber asFloat hex;
				 cr]! !

!LEB128 class methodsFor: 'as yet unclassified' stamp: 'edc 5/2/2019 08:07'!
readSignedLEB128: v 
"LEB128 readSignedLEB128: -8000"
	| more  value out count byte|
	out := OrderedCollection new.
(v isKindOf: Number) ifFalse:[
v first = $$ ifFalse:[
	value := v asNumber]
ifTrue:[value := (v splitBy:'$') last.
value :=  value  asNumber]]
ifTrue:[value := v].
	more := false.
	[more]
		whileFalse: [byte := value bitAnd: 127.
			count := byte bitAnd: 64.
			value := value >> 7.
			more := value = 0 & (count = 0) | (value = -1 & (count ~= 0)).
			more
				ifFalse: [byte := byte + 128].
			out add: byte].
	^ out! !

Object subclass: #MVP1Spec
	instanceVariableNames: ''
	classVariableNames: 'FullSpec JsonOpcodes SectionCode Types'
	poolDictionaries: ''
	category: 'WASM'!

!MVP1Spec commentStamp: 'edc 4/20/2018 10:40' prior: 0!
MVP1Spec class setup

Must read wasmOpcodes.obj from self directory
MVP1Spec setOpcodesDelJson: self on the code panel of inspector
MVP1Spec defineSectionCode.
MVP1Spec defineTypes.

!

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 4/20/2018 10:32'!
defineSectionCode
	"MVP1Spec defineSectionCode"
	SectionCode := Dictionary new.
	SectionCode at: 0 put: 'Custom'.
	SectionCode at: 1 put: 'Type'.
	SectionCode at: 2 put: 'Import'.
	SectionCode at: 3 put: 'Function'.
	SectionCode at: 4 put: 'Table'.
	SectionCode at: 5 put: 'Memory'.
	SectionCode at: 6 put: 'Global'.
	SectionCode at: 7 put: 'Export'.
	SectionCode at: 8 put: 'Start'.
	SectionCode at: 9 put: 'Element'.
	SectionCode at: 10 put: 'Code'.
	SectionCode at: 11 put: 'Data'! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 4/20/2018 10:30'!
defineTypes
	"MVP1Spec defineTypes"
	Types := Dictionary new.
	Types at: '7f' put: 'i32'.
	Types at: '7e' put: 'i64'.
	Types at: '7d' put: 'f32'.
	Types at: '7c' put: 'f64'.
	Types at: '70' put: 'anyfunc'.
	Types at: '60' put: 'function'! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 6/3/2018 07:26'!
getFullSpec
" MVP1Spec getFullSpec inspect"
^FullSpec ! !

!MVP1Spec class methodsFor: 'initialize-release' stamp: 'edc 9/17/2019 12:31'!
initialize
self defineTypes.
self defineSectionCode! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 4/20/2018 12:08'!
module
	"MVP1Spec module "
	^ #(0 97 115 109 1 0 0 0 ) asOrderedCollection! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 6/7/2018 06:29'!
opcodesDelJson
	"MVP1Spec opcodesDelJson inspect"
	^ JsonOpcodes! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 4/22/2018 10:01'!
sectionCode
	"MVP1Spec sectionCode"
	^ SectionCode! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 5/7/2018 17:21'!
sectionNames
	"MVP1Spec sectionNames"
	^ #('module' 'type' 'import' 'func' 'table' 'memory' 'global' 'export' 'start' 'elem' 'code'                     'data' )! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 6/2/2018 09:07'!
setFullSpec: aJson
" MVP1Spec setFullSpec: self"
FullSpec := aJson! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 4/20/2018 10:34'!
setOpcodesDelJson: anObject 
	"MVP1Spec setOpcodesDelJson: self"
	JsonOpcodes := anObject! !

!MVP1Spec class methodsFor: 'as yet unclassified' stamp: 'edc 4/20/2018 12:22'!
types
	"MVP1Spec types"
	^ Types! !

!Object class methodsFor: '*WASM' stamp: 'edc 4/20/2018 10:14'!
fileReaderServicesForFile: fullName suffix: suffix
	| services |
	services _ OrderedCollection new.
	(fullName asLowercase endsWith: '.obj') ifTrue: [ services add: self serviceLoadObject ].
	(fullName asLowercase endsWith: '.wasm') ifTrue: [services add: self serviceLoadWasm ].
		(fullName asLowercase endsWith: '.json') ifTrue: [ services add: self serviceLoadJson ].
(fullName asLowercase endsWith: '.wast') ifTrue: [ services add: self serviceLoadWast ].
(fullName asLowercase endsWith: '.wat') ifTrue: [ services add: self serviceLoadWat ].
	
	
	^ services.! !

!Object class methodsFor: '*WASM' stamp: 'edc 3/29/2018 12:18'!
readWasm: aStream
|instance|

instance :=
	WasmForensics new readWasm: aStream.
	instance inspect! !

!Object class methodsFor: '*WASM' stamp: 'edc 4/20/2018 10:13'!
readWast: aStream
|instance|

instance :=
	WastCompilerToWasm new readWast: aStream.
	instance inspect! !

!Object class methodsFor: '*WASM' stamp: 'edc 8/28/2017 08:10'!
serviceLoadWasm
	"Answer a service for opening a wasm file"
	^ (SimpleServiceEntry
		provider: self
		label: 'wasn file'
		selector: #readWasm:
		description: 'open a Wasm File'
		buttonLabel: 'wasm') argumentGetter: [ :fileList |
		fileList readOnlyStream ].! !

!Object class methodsFor: '*WASM' stamp: 'edc 4/20/2018 10:10'!
serviceLoadWast
	"Answer a service for opening a wasm file"
	^ (SimpleServiceEntry
		provider: self
		label: 'wast file'
		selector: #readWast:
		description: 'open a WebAssembly stack text format file'
		buttonLabel: 'wast') argumentGetter: [ :fileList |
		fileList readOnlyStream ].! !

!Object class methodsFor: '*WASM' stamp: 'edc 6/8/2019 06:27'!
serviceLoadWat
	"Answer a service for opening a wasm file"
	^ (SimpleServiceEntry
		provider: self
		label: 'wat file'
		selector: #readWast:
		description: 'open a WebAssembly text format  File'
		buttonLabel: 'wat') argumentGetter: [ :fileList |
		fileList readOnlyStream ].! !

Object subclass: #WasmForensics
	instanceVariableNames: 'wasm index numTypes numLine sectionSize sectionName wasmMorph instruction byte'
	classVariableNames: 'JsonOpcodes Opcodes'
	poolDictionaries: ''
	category: 'WASM'!

WasmForensics class
	instanceVariableNames: 'externalFolder'!

WasmForensics class
	instanceVariableNames: 'externalFolder'!

!WasmForensics class methodsFor: 'as yet unclassified' stamp: 'edc 11/9/2019 08:05'!
compareWasm: name1 with: name2 
	"WasmForensics compareWasm: 'sqrt.wasm'
	with: 'sqrt2.wasm'"
	| f1 f2  index byte1 byte2|
	Transcript show: String cr.
	Transcript show: '======  checking ======';
		 cr.
	index := 0.
	f1 := (StandardFileStream readOnlyFileNamed: self filePath + name1) binary.
	f2 := (StandardFileStream readOnlyFileNamed: self filePath + name2) binary.
f1 size = f2 size ifFalse:[^f2 size].
[f1 atEnd]
		whileFalse: [byte1 := f1 next.
			byte2 := f2 next.
			byte1 = byte2 ifTrue:[index := index + 1]
				ifFalse: [WasmLogger show: 'In position : ';
						 show: String cr;
						 show: index - 1.
					WasmLogger show: String cr;
						 show: '====>'.
					WasmLogger show: String cr;
						 show: 'Original ';
						 show: byte1 hex fill2zero.
					WasmLogger show: String cr;
						 show: 'This Program output   ';
						 show: byte2 hex fill2zero.
					WasmLogger show: String cr;
						 show: '====>';show: index.
^index := index + 1.
				]].
			^index ! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 3/29/2018 12:19'!
convertUint8Array: aString
|list byte  instance wasm |

wasm := OrderedCollection new.
list := (aString findTokens: ' ,').
list do:[ :ea | byte := (ea splitBy:'x') last .
wasm add: byte asHexNumber.



].

instance := self new.
instance wasm: wasm asByteArray.
WasmLogger filename:  'test.txt'.
	WasmLogger open.
	
	WasmLogger startLog.
instance processWasm

! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 8/24/2017 17:16'!
externalFolder

	^ externalFolder! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 8/24/2017 17:16'!
externalFolder: anObject

	externalFolder := anObject! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 3/25/2018 08:07'!
filePath
	^ FileDirectory default pathName , FileDirectory slash ! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 10/8/2017 07:33'!
opcodes
"WasmForensics opcodes "
^Opcodes! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 3/4/2018 05:31'!
opcodesDelJson
	"WasmForensics opcodesDelJson"
	^ JsonOpcodes! !

!WasmForensics class methodsFor: 'as yet unclassified' stamp: 'edc 11/19/2017 09:34'!
read
	"WasmForensics read"
	| p line f key value |
	p := 'opcode.txt'.
	f := StandardFileStream readOnlyFileNamed: p.
	[f atEnd]
		whileFalse: [line := f nextLine withBlanksTrimmed.
			Transcript show: line;
				 cr.
			key := (line splitBy: ' ') last.
			value := (line splitBy: ' ') first.
self opcodes at: key ifAbsent:[self  opcodes at: key put: value.]]! !

!WasmForensics class methodsFor: 'as yet unclassified' stamp: 'edc 11/6/2017 08:02'!
readOpcodesObj: anObject
	"WasmForensics readOpcodesObj: self"
	Opcodes := anObject.
	! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 3/31/2018 06:06'!
setOpcodesDelJson: anObject
	"WasmForensics setOpcodesDelJson: self"
	 JsonOpcodes := anObject! !

!WasmForensics class methodsFor: 'as yet unclassified' stamp: 'edc 2/2/2019 09:06'!
testFunc
"WasmForensics testFunc"
| names f1 test filePath dir|
filePath :=  FileDirectory default pathName , FileDirectory slash , 'wabt' , FileDirectory slash.
dir := FileDirectory on: filePath.
names := dir  fileNamesMatching: ' *.wasm'.
names do:[:ea|
f1 := (StandardFileStream readOnlyFileNamed: self filePath + ea) binary.
test := WasmForensics new.
test testQuick: f1 contents]! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 10/10/2019 06:52'!
testQuick: aWasm 
	"WasmForensics testQuick: self .
So no error"
	| instance |
	instance := self new.
	instance wasm: aWasm.
	WasmLogger open.
instance testQuick
	! !

!WasmForensics class methodsFor: 'accessing' stamp: 'edc 3/27/2018 08:52'!
testSection: aSection 
	"WasmForensics testSection: WatWasm module ,self .
So no error"
	| instance |
	instance := self new.
	instance wasm: aSection.
	instance processWasm! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/16/2019 04:11'!
arithmetic
"#('f32.neg' 'i32.sub' 'f64.max' 'i32.div_s' 'f32.copysign' 'i64.xor' 'f64.add' 'f64.neg' 'i32.shr_u' 'i64.clz' 'i32.or' 'i32.rem_u' 'i32.mul' 'f32.min' 'f64.ceil' 'i64.div_s' 'i64.mul' 'f64.min' 'i64.rotl' 'f64.sqrt' 'f32.trunc' 'i64.rem_u' 'i32.rotr' 'i32.add' 'f64.copysign' 'i32.ctz' 'i64.sub' 'f32.nearest' 'f64.nearest' 'i64.ctz' 'f32.div' 'i32.rotl' 'f64.trunc' 'i32.and' 'i32.shr_s' 'f32.sqrt' 'i32.rem_s' 'i64.shr_u' 'f32.abs' 'f32.mul' 'i32.shl' 'f32.ceil' 'f32.sub' 'i64.popcnt' 'i32.div_u' 'f32.max' 'i64.add' 'i64.rem_s' 'i32.xor' 'f32.add' 'f64.sub' 'i32.clz' 'f32.floor' 'f64.div' 'i64.div_u' 'i64.and' 'i64.or' 'f64.mul' 'i64.rotr' 'f64.abs' 'i64.shl' 'i64.shr_s' 'i32.popcnt' 'f64.floor'),"

	^ 'nothing'! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 10/10/2019 07:28'!
badCode
| bodySize count |

	self numTypes: self unsignedLEB128.count := 0.
	WasmLogger show: '  num functions'.
	self numTypes timesRepeat: [WasmLogger show: String cr.
			WasmLogger show: numLine;
				 show: '     '.
			numLine := numLine + 1.
			WasmLogger show: '  function body ';
				 show: count.
			bodySize := self unsignedLEB128: 'body size'.
			
			WasmLogger show: '; func body size.)'.
			count := count + 1.
	self halt]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:50'!
badSection:stops
	| sectionCode ostr sN |
	index := index + 1.
	sectionCode := self wasm at: index.
	sectionName := MVP1Spec sectionCode at: sectionCode.
	sN := sectionName asLowercase.
	
	ostr := '; section ' , sectionName , '  (' , sectionCode asString , ')'.
	self newLoggerLine.
	WasmLogger show: ostr.
	self newLoggerLine.
	WasmLogger show: (index - 1) hex fill7zero;
		 show: '     '.
	WasmLogger show: sectionCode hex fill2zero.
	WasmLogger show: '; section code '.
	self sectionSize: self unsignedLEB128.
	"wasmMorph wasm last setBalloonText: 'section size'."
	
	self numTypes: self unsignedLEB128.
	
	WasmLogger show: '; num ' , sectionName asLowercase , 's   ;'.
	sectionCode caseOf: {
		[1] -> [self readType].
		[2] -> [self readImport].
		[3] -> [self readFunction2].
		[4] -> [self readTable].
		[5] -> [self readMemory].
		[6] -> [self readGlobal].
		[7] -> [self readExport].
		[8] -> [self readStart].
		[9] -> [self readElement].
		[10] -> [self readCode].
		[11] -> [self readData]}.
! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:42'!
byte2
| byte s|
	index _ index + 1.
index > wasm size ifFalse:[
	WasmLogger show: ' '.
byte :=(self wasm at: index).
		s :=  byte hex fill2zero asLowercase.
"wasmMorph wasm add: ((MemoryCell new) section:sectionName asLowercase;label: s)."
	WasmLogger show: s.
	
	self sectionSize > 0 ifTrue: [ self sectionSize: self sectionSize - 1 ]].! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/18/2017 17:46'!
byte4
index < wasm size ifTrue:[ 
	index _ index + 1.
	WasmLogger show: ' '.
		
	WasmLogger show: (self wasm at: index) hex fill2zero asLowercase.
self sectionSize > 0 ifTrue: [ self sectionSize: self sectionSize - 1 ].
index < wasm size ifTrue:[ 
index _ index + 1.
		
	WasmLogger show: (self wasm at: index) hex fill2zero asLowercase].
	
	self sectionSize > 0 ifTrue: [ self sectionSize: self sectionSize - 1 ]]! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/8/2019 08:37'!
call
#('call_indirect' 'call').
	self getbyte.
			WasmLogger show: '; function index'! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 1/18/2019 10:03'!
checkWasm: anOrderedCollection named: fileName 

	self wasm: anOrderedCollection.
	WasmLogger filename: fileName , '.txt'.
	WasmLogger clear.
	
	WasmLogger startLog.
	self processWasm! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/16/2019 03:34'!
comparison
	#('f64.le' 'f64.lt' 'i64.ne' 'f32.ne' 'i64.eqz' 'i64.gt_u' 'i64.ge_u' 'i32.eq' 'i32.gt_u' 'i64.gt_s' 'f64.eq' 'i64.lt_u' 'f32.ge' 'i64.le_u' 'i64.ge_s' 'f32.gt' 'i32.lt_u' 'i64.lt_s' 'i32.gt_s' 'f32.le' 'i64.le_s' 'f32.lt' 'i32.lt_s' 'i32.ge_u' 'i32.le_u' 'i32.ge_s' 'i64.eq' 'i32.ne' 'f64.ne' 'f32.eq' 'f64.ge' 'i32.le_s' 'f64.gt' 'i32.eqz').
	^ 'nothing'! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/16/2019 03:44'!
control
	#('select' 'if' 'br_table' 'br_if' 'drop' 'unreachable' 'loop' 'block' 'nop' 'return' 'end' 'br' 'else').
	self getbyte.
	
byte = 64 ifTrue:[WasmLogger show: ';  void'.]
ifFalse:[byte = 11 ifTrue:[WasmLogger show: ';  end'.]
ifFalse:[WasmLogger show: 'break depth']].! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/16/2019 03:31'!
conversion
	#('i32.trunc_s/f32' 'f32.convert_u/i64' 'i64.extend_s/i32' 'i32.trunc_u/f32' 'f64.promote/f32' 'f64.convert_u/i64' 'i64.extend_u/i32' 'i32.trunc_s/f64' 'i64.trunc_s/f32' 'f64.reinterpret/i64' 'i64.reinterpret/f64' 'i32.trunc_u/f64' 'f32.convert_s/i32' 'f64.convert_s/i32' 'i64.trunc_u/f32' 'f32.reinterpret/i32' 'i32.reinterpret/f32' 'f32.convert_u/i32' 'f64.convert_u/i32' 'i32.wrap/i64' 'f32.demote/f64' 'i64.trunc_s/f64' 'f32.convert_s/i64' 'i64.trunc_u/f64' 'f64.convert_s/i64'),
	self halt.! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 5/2/2019 07:27'!
getBadByte: stop
	| byte s sN|
sN :=  sectionName asLowercase.

	index < stop
		ifTrue: [self newLoggerLine.
			WasmLogger show: index hex fill7zero asLowercase.
			index := index + 1.
			WasmLogger show: ' '.
			byte := self wasm at: index.
s :=  byte hex fill2zero asLowercase.
wasmMorph wasm add: ((MemoryCell new) section:sN;label: s).
			WasmLogger show:s.
			self sectionSize > 0
				ifTrue: [self sectionSize: self sectionSize - 1]].
	^ byte! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:20'!
getbyte
	|  s sN|
sN :=  sectionName asLowercase.

	index < wasm size
		ifTrue: [self newLoggerLine.
			WasmLogger show: index hex fill7zero asLowercase.
			index := index + 1.
			WasmLogger show: ' '.
			byte := self wasm at: index.
s :=  byte hex fill2zero asLowercase.
"wasmMorph wasm add: ((MemoryCell new) section:sN;label: s)."
			WasmLogger show:s.
			self sectionSize > 0
				ifTrue: [self sectionSize: self sectionSize - 1]].
	^ byte! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:43'!
getbyte: thisSection
	| byte s m|
	index <  wasm size
		ifTrue: [self newLoggerLine.
			WasmLogger show: index hex fill7zero asLowercase.
			index := index + 1.
			WasmLogger show: ' '.
			byte := self wasm at: index.
s :=  byte hex fill2zero asLowercase.
"m := MemoryCell new.
m section: thisSection.
m label: s.

wasmMorph wasm add: m."
			WasmLogger show:s.
			self sectionSize > 0
				ifTrue: [self sectionSize: self sectionSize - 1]].
	^ byte! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 8/26/2017 08:35'!
index
	"Answer the value of index"

	^ index! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 8/26/2017 08:35'!
index: anObject
	"Set the value of index"

	index _ anObject! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 11/20/2017 10:03'!
limits
	| flags |
	self getbyte.
	flags := self wasm at: index.
	WasmLogger show: ' ';
		 show: '; limits: flags '.
	
	self unsignedLEB128.
	WasmLogger show: ' ';
		 show: '; limits: initial '.
	
	"flags varuint1 1 if the maximum field is present, 0
	otherwise initial varuint32 initial length (in units of
	table elements or wasm pages)
	maximum varuint32? only present if specified by
	flags "
	flags > 0
		ifTrue: [self getbyte.
			WasmLogger show: ' ';
				 show: '; limits: max '.
			]! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/16/2019 03:59'!
load
	#('i32.load16_u' 'i64.load8_s' 'i64.load' 'i32.load8_s' 'f64.load' 'i32.load8_u' 'i32.load' 'i32.load16_s' 'f32.load').
	self getbyte.
	WasmLogger show: '; alignment'.
	self getbyte.
		WasmLogger show: '; load offset'.
		! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/16/2019 04:06'!
memory
	#('i64.store32' 'i64.store' 'i64.load32_u' 'i32.store8' 'i64.store16' 'i64.store8' 'i32.store16' 'i64.load8_u' 'i64.load16_s' 'f32.store' 'i32.store' 'i64.load32_s' 'f64.store' 'i64.load16_u').
		self getbyte.
	WasmLogger show: '; alignment'.
	self getbyte.
	WasmLogger show: '; store offset'.
	! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/20/2017 09:23'!
newLoggerLine
WasmLogger show: String cr.
	WasmLogger show: numLine;
		 show: '     '.
	numLine := numLine + 1.! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 8/26/2017 08:36'!
numTypes
	"Answer the value of numTypes"

	^ numTypes ifNil:[ numTypes :=0]! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 8/26/2017 08:35'!
numTypes: anObject
	"Set the value of numTypes"

	numTypes _ anObject! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 08:07'!
opcode: value 
	|  tuple|
tuple :=(MVP1Spec opcodesDelJson associationsSelect:[:assoc | (assoc value first) = value]) associations first.
WasmLogger show: '    ';show:tuple key.
instruction :=tuple key.
self perform: tuple value last.! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/16/2019 03:32'!
operation
	#('current_memory' 'grow_memory').
	self halt.! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 5/2/2019 06:25'!
processBadWasm
self halt.
	wasmMorph := WasmMemory new.
	sectionName := 'Module'.
wasmMorph map at:  'module' put: 0.
	numLine := 1.
	self index: 0.
	(wasm at: 5)
			= 1
		ifFalse: [WasmLogger show: 'bad wasm file version:'.
			WasmLogger
				show: (wasm at: 5).
			WasmLogger show: ' (expected 0x1)'.
			self halt].
	2
		timesRepeat: [self getbyte.
			3
				timesRepeat: [self byte2].
			WasmLogger show: ' '].
	"Guess type"
	[index < self wasm size]
		whileTrue: [self section].
	WasmLogger show: String cr;
		 show: 'SUCESS '.
	wasmMorph show! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 5/2/2019 07:08'!
processBadWasm: stops

	wasmMorph := WasmMemory new.
	sectionName := 'Module'.
wasmMorph map at:  'module' put: 0.
	numLine := 1.
	self index: 0.
	(wasm at: 5)
			= 1
		ifFalse: [WasmLogger show: 'bad wasm file version:'.
			WasmLogger
				show: (wasm at: 5).
			WasmLogger show: ' (expected 0x1)'.
			self halt].
	2
		timesRepeat: [self getbyte.
			3
				timesRepeat: [self byte2].
			WasmLogger show: ' '].
	"Guess type"
	[index < stops first]
		whileTrue: [Transcript show:index;cr.self halt.	self badSection:stops].

.! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:55'!
processWasm
	"wasmMorph := WasmMemory new."
	sectionName := 'Module'.
"wasmMorph map at:  'module' put: 0."
	numLine := 1.
	self index: 0.
	(wasm at: 5)
			= 1
		ifFalse: [WasmLogger show: 'bad wasm file version:'.
			WasmLogger
				show: (wasm at: 5).
			WasmLogger show: ' (expected 0x1)'.
			self halt].
	2
		timesRepeat: [self getbyte.
			3
				timesRepeat: [self byte2].
			WasmLogger show: ' '].
	"Guess type"
	[index < self wasm size]
		whileTrue: [self section].
	WasmLogger show: String cr;
		 show: 'SUCESS '.
	"wasmMorph show"! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:22'!
readCode
	| count numFunctions bodySize baseIndex localDeclCount localTypeCount  |

	count := 0.
	numFunctions := self numTypes.
	"wasmMorph wasm last setBalloonText: 'num functions'."
	numFunctions
		timesRepeat: [WasmLogger show: String cr.
			WasmLogger show: numLine;
				 show: '     '.
			numLine := numLine + 1.
			WasmLogger show: '  function body ';
				 show: count.
			bodySize := self unsignedLEB128: 'body size'.
			baseIndex := index.
			WasmLogger show: '; func body size.)'.
			self getbyte.
			localDeclCount := self wasm at: index.
			"wasmMorph wasm last setBalloonText: 'local decl count'."
			WasmLogger show: '; local decl count)'.
			
			localDeclCount
				timesRepeat: [localTypeCount := self getbyte.
				"	wasmMorph wasm last setBalloonText: 'local type count'."
					WasmLogger show: '; local type count)'.
					byte := self getbyte hex fill2zero asLowercase.
					WasmLogger show: '    '
							, (MVP1Spec types at: byte)].
			[index - baseIndex = bodySize]
				whileFalse: [self untilEnd].
			count := count + 1].
	[self sectionSize > 0]
		whileTrue: [self opcode: self getbyte.
			self show]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:53'!
readCode:stops
	| count numFunctions bodySize baseIndex localDeclCount localTypeCount byte |
	count := 0.
	numFunctions := self numTypes.
	"wasmMorph wasm last setBalloonText: 'num functions'."
	numFunctions
		timesRepeat: [WasmLogger show: String cr.
			WasmLogger show: numLine;
				 show: '     '.
			numLine := numLine + 1.
			WasmLogger show: '  function body ';
				 show: count.
			bodySize := self unsignedLEB128: 'body size'.
			baseIndex := index.
			WasmLogger show: '; func body size.)'.
			self getbyte.
			localDeclCount := self wasm at: index.
			"wasmMorph wasm last setBalloonText: 'local decl count'."
			WasmLogger show: '; local decl count)'.
			localDeclCount
				timesRepeat: [localTypeCount := self getbyte.
					"wasmMorph wasm last setBalloonText: 'local type count'."
					WasmLogger show: '; local type count)'.
					byte := self getbyte hex fill2zero asLowercase.
					WasmLogger show: '    '
							, (MVP1Spec types at: byte)].
			[index - baseIndex = bodySize]
				whileFalse: [self untilEnd:stops].
			count := count + 1].
	[self sectionSize > 0]
		whileTrue: [self opcode: self getbyte.
			self show]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 4/1/2018 09:47'!
readData
	| count dss |

	count := 0.
	self numTypes
		timesRepeat: [WasmLogger show: String cr;
				 show: numLine;
				 show: '     '.
			numLine := numLine + 1.
			WasmLogger show: ' ; data segment header  ';
				 show: count.
			self getbyte.
			WasmLogger show: ' ;  ; memory index'.
			self untilEnd.
			dss := self unsignedLEB128.
			self sectionSize: dss.
			WasmLogger show: '   ; data segment size  '.
			self newLoggerLine.
			WasmLogger show: ' ; data segment data    ';
				 show: count.
			dss < 16
				ifTrue: [self newLoggerLine.
					WasmLogger show: index hex fill7zero asLowercase.
					dss
						timesRepeat: [self byte2]]
				ifFalse: [dss := (dss / 16) asInteger.
					dss
						timesRepeat: [self newLoggerLine.
							WasmLogger show: index hex fill7zero asLowercase.
							8
								timesRepeat: [self byte4]]].
			self newLoggerLine.
			[self sectionSize > 1]
				whileTrue: [self byte4].
			self sectionSize > 0
				ifTrue: [self byte2].
			WasmLogger show: ' ; data segment data '.
			count := count + 1]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 12/4/2017 10:44'!
readElement
	| count numIndices |
	count := 0.
	self numTypes
		timesRepeat: [WasmLogger show: String cr.
			WasmLogger show: numLine;
				 show: '     '.
			numLine := numLine + 1.
			WasmLogger show: '  ; elem segment header ';
				 show: count.
			self getbyte.
			WasmLogger show: '   table index '.
			self untilEnd.
			self getbyte.
			numIndices := self wasm at: index.
			WasmLogger show: '; num function indices'.
			
			numIndices
				timesRepeat: [self unsignedLEB128.
					WasmLogger show: ';  function index'.
					].
			count := count + 1]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:53'!
readExport
	| strlen |

	numTypes
		timesRepeat: [
			strlen := self readString.
			WasmLogger show: strlen;
				 show: '    ; export name'.
			self getbyte.
"wasmMorph wasm last setBalloonText: 'export kind'."
			WasmLogger show: '; export kind'.
			self unsignedLEB128.
"wasmMorph wasm last setBalloonText: 'func index'."

			WasmLogger show: '; export func index'].
! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:23'!
readFunction
	| numPar  numResults |
	WasmLogger show: '; func'.
	self getbyte.
	numPar := self wasm at: index.
	"wasmMorph wasm last setBalloonText:'num
	params'. "
	WasmLogger show: '; num params'.
	numPar
		timesRepeat: [byte := self getbyte.
			byte := byte hex fill2zero asLowercase.
			WasmLogger show: ' ';
				
				show: (MVP1Spec types at: byte)].
	self getbyte.
	"current specification limits the number of
	func results up to 1, in future
	implementations this
	could be
	removed"
	numResults := self wasm at: index.
	WasmLogger show: '  ';
		 show: ' ; num results'.
	"wasmMorph wasm last setBalloonText:'
	num results'."
	numResults > 0
		ifTrue: [numResults
				timesRepeat: [byte := self getbyte.
					byte := byte hex fill2zero asLowercase.
					WasmLogger show: ' ';
						
						show: (MVP1Spec types at: byte)]]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:53'!
readFunction2
| count numFunctions s|

	count _ 0.
	numFunctions := self numTypes.

	numFunctions timesRepeat: [self getbyte.
s := ' function ',count asString,' signature index '. 
"wasmMorph wasm last setBalloonText:s."
		WasmLogger
			 show: '  function ';
			 show: count;
			show:' signature index '. 
		count _ count + 1].


	! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 10/9/2019 09:53'!
readGlobal
	[self sectionSize > 0]
		whileTrue: [self opcode: self getbyte]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 6/7/2019 07:35'!
readGlobal: instruction 
WasmLogger show: '     ';show:instruction.
	instruction caseOf: {
		['get_global'] -> 
			[self getbyte.
			WasmLogger show: '; global index'.
			^ true].
		['i32.const'] -> [self getbyte.
							WasmLogger show: '; i32 literal'.
					^ true].
['f32.const'] -> [self newLoggerLine..4
				timesRepeat: [self byte2].
							WasmLogger show: '; f32 literal'.

			WasmLogger show: ' '.

					^ true].
		['i32'] -> [self getbyte.
							WasmLogger show: '; global mutability'.
					^ true].
['f32'] -> [self getbyte.
							WasmLogger show: '; global mutability'.
					^ true].
['f64'] -> [self getbyte.
							WasmLogger show: '; global mutability'.
					^ true].
		['end'] -> [^ true]}
otherwise: [self error: 'This  is unsolved.']! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 5/7/2018 15:50'!
readImport
	| count |

	count := 0.
	self numTypes
		timesRepeat: [WasmLogger show: String cr;
				 show: numLine;
				 show: '     '.
			numLine := numLine + 1.
			WasmLogger show: '  import header ';
				 show: count.

			count := count + 1.
			self readImport2]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:22'!
readImport2
	| ostr kind  opcode |

	ostr := self readString.
	WasmLogger show: '  ';
		 show: ostr;
		 show: '    ; import module name'.
	WasmLogger.
	ostr := self readString.
	WasmLogger show: '  ';
		 show: ostr;
		 show: '    ; import field name'.
	WasmLogger.
	kind := self getbyte.
	WasmLogger show: '; import kind'.

	WasmLogger.
	kind caseOf: {
		[0] -> 
			[byte := self getbyte.
			WasmLogger show: '; import signature index'].
		["Function"
		1] -> 
			[self opcode: self getbyte hex fill2zero asLowercase.
			self readImport3].
		["Table"
		2] -> [self readImport3].
		["Memory"
		3] -> 
			[opcode := self getbyte hex fill2zero asLowercase.
				Transcript show: (MVP1Spec types at: opcode).
			self getbyte.
			Transcript show: '; global mutability ']}! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 6/9/2019 09:20'!
readImport3
|flags|
	flags :=self getbyte.
		WasmLogger
			 show: ';limits: flags'. WasmLogger.
self unsignedLEB128.
		WasmLogger
			 show: ';limits: initial'. WasmLogger.
flags > 0 ifTrue:[self unsignedLEB128.
		WasmLogger
			 show: ';limits: max'. WasmLogger.].! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/10/2017 10:26'!
readMemory
	| count |
	count := 0.
	self numTypes
		timesRepeat: [WasmLogger show: ' ; memory  ';
				 show: count.
			
			self limits.
			count := count + 1]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 10/26/2017 12:01'!
readStart
^'do nothing'! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:24'!
readString
	|  strlen |
	numLine := numLine + 1.
	self getbyte.
	WasmLogger show: '; string length ;'.
	"wasmMorph wasm last setBalloonText:
	'string length'."
	WasmLogger show: String cr.
	strlen := String new.
	WasmLogger show: numLine;
		 show: '     '.
	WasmLogger show: index hex fill7zero.
	1
		to: (self wasm at: index)
		do: [:ch | 
			self byte2.
			byte := self wasm at: index.
			"wasmMorph wasm last
			setBalloonText:(Character value: byte)
			asString. "
			strlen := strlen + (Character value: byte) asString].
	WasmLogger show: '   '.
	^ strlen! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:24'!
readTable
	|  numTables count |
	count := 0.
	numTables := self numTypes.
	numTables
		timesRepeat: [WasmLogger show: '; table ';
				 show: count.
			byte := self getbyte.
			byte := byte hex fill2zero asLowercase.
			byte = '70'
				ifFalse: [self error].
			WasmLogger show: '   anyfunc'.
			self limits.
			count := count + 1]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:24'!
readType
	|  count |
	count := 0.
	self numTypes
		timesRepeat: [self newLoggerLine.
			WasmLogger show: ' ; type  ';
				 show: count.
			count := count + 1.
			byte := self getbyte.
			byte := (self wasm at: index) hex fill2zero asLowercase.
			byte = '60'
				ifTrue: ["wasmMorph wasm last
					setBalloonText: 'func'."
					self readFunction]]! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 3/29/2018 12:20'!
readWasm: aStream 
	| fileName |
	fileName := (aStream name splitBy: FileDirectory slash) last.
	fileName := (fileName splitBy: '.') first.
	self wasm: aStream binary contents.
	WasmLogger filename: fileName , '.txt'.
	WasmLogger open.
	"WasmLogger clear."
	WasmLogger startLog.
	
	self processWasm! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 5/2/2019 06:32'!
readWasm: wasm stopAt: stops
	
	self wasm: wasm.

	WasmLogger clear.
	WasmLogger startLog.
	
	self processBadWasm: stops! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:56'!
section
	| sectionCode ostr sN |
	index := index + 1.
	sectionCode := self wasm at: index.
	sectionName := MVP1Spec sectionCode at: sectionCode.
	sN := sectionName asLowercase.
	"wasmMorph wasm add: MemoryCell new.
	wasmMorph wasm last section: sN.
	wasmMorph wasm last label: sectionCode.
	wasmMorph wasm last setBalloonText: sectionName.
	wasmMorph map at: sN put: index."
	ostr := '; section ' , sectionName , '  (' , sectionCode asString , ')'.
	self newLoggerLine.
	WasmLogger show: ostr.
	self newLoggerLine.
	WasmLogger show: (index - 1) hex fill7zero;
		 show: '     '.
	WasmLogger show: sectionCode hex fill2zero.
	WasmLogger show: '; section code '.
	self sectionSize: self unsignedLEB128.
	"wasmMorph wasm last setBalloonText: 'section size'."
	WasmLogger show: '; section size '.
	self numTypes: self unsignedLEB128.
	"wasmMorph wasm last setBalloonText: 'num functions'."
	WasmLogger show: '; num ' , sectionName asLowercase , 's   ;'.
	sectionCode caseOf: {
		[1] -> [self readType].
		[2] -> [self readImport].
		[3] -> [self readFunction2].
		[4] -> [self readTable].
		[5] -> [self readMemory].
		[6] -> [self readGlobal].
		[7] -> [self readExport].
		[8] -> [self readStart].
		[9] -> [self readElement].
		[10] -> [self readCode].
		[11] -> [self readData]}.
	"wasmMorph helper.
	wasmMorph show"! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:44'!
sectionQuick
	| sectionCode ostr sN  |
	sectionCode := self wasm at: index.
	sectionName := MVP1Spec sectionCode at: sectionCode.
	sN := sectionName asLowercase.
	"wasmMorph wasm add: MemoryCell new.
	wasmMorph wasm last section: sN.
	wasmMorph wasm last label: sectionCode.
	wasmMorph wasm last setBalloonText: sectionName.
	wasmMorph map at: sN put: index."
	ostr := '; section ' , sectionName , '  (' , sectionCode asString , ')'.
	self newLoggerLine.
	WasmLogger show: ostr.
	self newLoggerLine.
	WasmLogger show: (index - 1) hex fill7zero;
		 show: '     '.
	WasmLogger show: sectionCode hex fill2zero.
	WasmLogger show: '; section code '.
	self sectionSize: self unsignedLEB128.
	wasmMorph wasm last setBalloonText: 'section size'.
	WasmLogger show: '; section size '.
	
	sN = 'code'
		ifTrue: [
			self badCode]
		ifFalse:[self index: self index + self sectionSize.]! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 9/1/2017 11:17'!
sectionSize
	"Answer the value of sectionSize"
	^ sectionSize ifNil: [ sectionSize _ 0 ].! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 9/1/2017 11:08'!
sectionSize: anInteger
	"Set the value of sectionSize"

	sectionSize _ anInteger! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 5/7/2018 08:07'!
show
| r |
r := AlignmentMorph newRow vResizing: #shrinkWrap.
r addAllMorphs: wasmMorph .
r openInHand.
self halt.! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:21'!
signedLEB128
	| result shift  b |
	result _ 0.
	shift _ 0.
	self getbyte.
	[
	byte _ self wasm at: index.
	b _ byte bitAnd: 127.
	b _ b << shift.
	result _ result + b.
	shift _ shift + 7.
	byte _ (byte  bitAnd: 128) >> 7.
	byte = 0 ] whileFalse: [
		
		self byte2 ].
	
	
	^ result.! !

!WasmForensics methodsFor: 'opcode Category' stamp: 'edc 11/8/2019 07:40'!
special
	| word |
	(#('get_local' 'get_global' 'set_local' 'set_global') includes: instruction)
		ifTrue: [word := (instruction findTokens: '_') last.
			self getbyte.
			WasmLogger show: '; ';
				 show: word;
				 show: '  index'.
			^ true].
	instruction caseOf: {
		['i32.const'] -> 
			[self signedLEB128.
			WasmLogger show: '; i32 literal '].
		['f64.const'] -> 
			[self newLoggerLine.
			WasmLogger show: index hex fill7zero asLowercase.
			8
				timesRepeat: [self byte2].
			WasmLogger show: '; f64 literal '].
		['i64.const'] -> 
			[self signedLEB128.
			WasmLogger show: '; i64 literal '].
		['f32.const'] -> 
			[self newLoggerLine.
			WasmLogger show: index hex fill7zero.
			4
				timesRepeat: [self byte2].
			WasmLogger show: '; f32 literal '].
		['tee_local'] -> []}! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 12/8/2018 08:32'!
testQuick
Transcript clear.
	wasmMorph := WasmMemory new.
	sectionName := 'Module'.
	wasmMorph map at: 'module' put: 0.
	numLine := 1.
	self index: 0.
	(wasm at: 5)
			= 1
		ifFalse: [WasmLogger show: 'bad wasm file version:'.
			WasmLogger
				show: (wasm at: 5).
			WasmLogger show: ' (expected 0x1)'.
			self halt].
	2
		timesRepeat: [self getbyte.
			3
				timesRepeat: [self byte2].
			WasmLogger show: ' '].
	"Guess type"

	[index < self wasm size]
		whileTrue: [index := index + 1.self sectionQuick].
	WasmLogger show: String cr;
		 show: 'SUCESS '.
	wasmMorph show! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/7/2019 06:45'!
unsignedLEB128
| result shift byte b|
	result _ 0.
	shift _ 0.

	self getbyte .
"wasmMorph wasm last setBalloonText: 'section size'."
	[byte _ self wasm at: index.
	b _ byte bitAnd: 127.
	b _ b << shift.
	result _ result + b.
	byte _ byte >> 7.
	byte > 0 ] whileTrue: [
		shift _ shift + 7.
		self byte2.
"wasmMorph wasm last setBalloonText: 'section size'. "].
	^ result! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/13/2019 09:21'!
unsignedLEB128: aString
| result shift  b s|
	result _ 0.
	shift _ 0.
s :=  sectionName asLowercase.
s  = 'function' ifTrue:[s := 'func'].
	self getbyte:s .
"wasmMorph wasm last setBalloonText: aString."
	[byte _ self wasm at: index.
	b _ byte bitAnd: 127.
	b _ b << shift.
	result _ result + b.
	byte _ byte >> 7.
	byte > 0 ] whileTrue: [
		shift _ shift + 7.
		self byte2.
"wasmMorph wasm last setBalloonText: 'section size'." ].
	^ result! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/16/2019 04:00'!
untilEnd
	"wasmMorph wasm last
	setBalloonText: (self class opcodesDelJson
	keyAtValue: byte)."
	
	[byte := self getbyte.
	byte = 11]
		whileFalse: [byte
				ifNil: [byte := 11
					"'0b' = 11 = end block"]
				ifNotNil: [self opcode: byte]].
	WasmLogger show: ';  end'.
	! !

!WasmForensics methodsFor: 'as yet unclassified' stamp: 'edc 11/4/2019 14:11'!
untilEnd: stops 
	| byte |
	self halt.
	[byte := self getbyte: stops first.
	wasmMorph wasm last
		setBalloonText: (self class opcodesDelJson keyAtValue: byte).
	byte
		ifNil: [byte := 11
			"'0b' = 11 = end block"]
		ifNotNil: [self opcode: byte].
	byte = 11] whileFalse! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 8/26/2017 07:48'!
wasm
	"Answer the value of wasm"

	^ wasm! !

!WasmForensics methodsFor: 'accessing' stamp: 'edc 8/26/2017 07:48'!
wasm: anObject
	"Set the value of wasm"

	wasm _ anObject! !

Object subclass: #WasmLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WASM'!

WasmLogger class
	instanceVariableNames: 'entries firstIndex lastIndex accessSemaphore unfinishedEntry logToFile showOnDisplay innerRectangle lastDisplayTime filename'!

!WasmLogger commentStamp: '<historical>' prior: 0!
A new implementation of Transcript.
- Thread safe.
- Very fast.
- Independent of Morphic or any other UI framework.
- Immediate feedback.
- Can log to file.
- Not an editor. Only used for output.
- All protocol is on the Class side!

WasmLogger class
	instanceVariableNames: 'entries firstIndex lastIndex accessSemaphore unfinishedEntry logToFile showOnDisplay innerRectangle lastDisplayTime filename'!

!WasmLogger class methodsFor: 'private' stamp: 'edc 2/12/2018 08:31'!
addEntry: aString 
	"Add a new entrie to the entries circular list. If full, a
	new entry will replace the oldest one."
	self addEntry: aString logToFile: aString! !

!WasmLogger class methodsFor: 'private' stamp: 'edc 10/3/2019 19:58'!
addEntry: aString logToFile: otherString 
	"Add a new entrie to the entries circular list. If full, a
	new entry will replace the oldest one."
	| stream |

	accessSemaphore
		critical: ["Internal circular collection
			lastIndex := lastIndex \\ self maxEntries + 1.
			firstIndex = lastIndex
				ifTrue: [firstIndex := firstIndex \\ self maxEntries + 1].
			entries at: lastIndex put: aString.
			external file"
			otherString
				ifNotNil: [
					[stream := StandardFileStream oldFileNamed: self filename.
					stream setToEnd; nextPutAll: otherString; flush]
						ensure: [stream close]]]! !

!WasmLogger class methodsFor: 'constants' stamp: 'jmv 2/18/2011 16:49'!
borderWidth
	^1! !

!WasmLogger class methodsFor: 'class initialization' stamp: 'edc 3/25/2018 06:57'!
clear
Transcript clear.! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'edc 7/7/2011 08:05'!
closed
^false! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'jmv 2/18/2011 11:20'!
cr
	"WriteStream protocol.
	In the older TranscriptStream, it added a CR character.
	Now, finish the current incomplete entry."

	self finishEntry! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'jmv 2/18/2011 11:20'!
crtab
	"WriteStream protocol.
	End the current entry, and start a new one starting with a single tab character."

	self cr; tab! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'jmv 2/18/2011 11:21'!
endEntry
	"For compatibility with old TranscriptStream. nop here"! !

!WasmLogger class methodsFor: 'constants' stamp: 'edc 9/20/2017 12:02'!
filename
^filename ifNil:[
	^ 'transcript.txt'].! !

!WasmLogger class methodsFor: 'constants' stamp: 'edc 3/29/2018 12:42'!
filename: aString 
	filename := aString.

StandardFileStream forceNewFileNamed: aString! !

!WasmLogger class methodsFor: 'private' stamp: 'edc 11/7/2017 06:37'!
finishEntry
	| newEntry |
	newEntry _ unfinishedEntry contents.
	unfinishedEntry reset.
	self addEntry: newEntry.
	! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'jmv 2/18/2011 11:21'!
flush
	"For compatibility with old TranscriptStream. nop here"! !

!WasmLogger class methodsFor: 'class initialization' stamp: 'edc 11/18/2017 16:57'!
initialize
	"
	WasmLogger initialize
	"
	showOnDisplay := true.
	innerRectangle := 20 @ 20 extent: 300 @ 500.
	logToFile := false.
	entries := Array new: self maxEntries.
	unfinishedEntry := '' writeStream.
	accessSemaphore := Semaphore forMutualExclusion! !

!WasmLogger class methodsFor: 'preferred protocol' stamp: 'edc 11/18/2017 16:44'!
log: aString
	self addEntry: aString.
	! !

!WasmLogger class methodsFor: 'constants' stamp: 'edc 11/19/2017 19:05'!
maxEntries
	^ 100000! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'edc 11/18/2017 16:47'!
nextPut: aCharacter
	"WriteStream protocol.
	Append aCharacter to the unfinishedEntry.
	cr characters sent with this message do NOT finish the current unfinishedEntry."

	unfinishedEntry nextPut: aCharacter.
	! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'edc 2/12/2018 08:28'!
nextPutAll: aString 
	"WriteStream protocol.
	Append aString to the unfinishedEntry.
	cr characters sent with this message do NOT finish
	the current unfinishedEntry."
 
	unfinishedEntry nextPutAll: aString.
self log: aString.! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'edc 4/30/2019 21:05'!
open
	| r t|
	r := MenuMorph confirm: 'Open a Transcript ?'.
	r
		ifTrue: [
t :=Transcript openLabel:self filename. 
t topLeft: 0@20.
t height: 190.
t width: World width]
		ifFalse: [Transcript clear.showOnDisplay := false]! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'jmv 2/18/2011 11:20'!
print: anObject
	"Stream protocol"
	anObject printOn: self! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'edc 2/12/2018 08:21'!
show: anObject 
	"Old TranscriptStream protocol."

	self nextPutAll: anObject asString.
	Transcript show: anObject! !

!WasmLogger class methodsFor: 'preferred protocol' stamp: 'jmv 2/18/2011 16:46'!
showOnDisplay: aBoolean
	"
	self logToFile
	"
	showOnDisplay _ aBoolean! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'jmv 2/18/2011 11:22'!
space
	"WriteStream protocol.
	Append a space character to the receiver."

	self nextPut: Character space! !

!WasmLogger class methodsFor: 'preferred protocol' stamp: 'edc 3/30/2018 09:54'!
startLog
	logToFile _ true.
lastIndex :=  0.! !

!WasmLogger class methodsFor: 'old WasmLogger compatibility' stamp: 'jmv 2/18/2011 11:22'!
tab
	"WriteStream protocol.
	Append a tab character to the receiver."

	self nextPut: Character tab! !

Object variableSubclass: #WasmMemory
	instanceVariableNames: 'wasm numTypes nunFunctions numExports numCodes numImports numDatas numGlobals index map'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WASM'!

!WasmMemory methodsFor: 'as yet unclassified' stamp: 'edc 10/18/2018 07:54'!
helper
	| r c|
c := OrderedCollection new.
	r := AlignmentMorphBob1 new borderWidth: 8;
				 borderColor: Color black;
				 color: Color white.
map keys reverse do: [:sectionName|c add:((MemoryCell new) section: sectionName asLowercase;label: sectionName)].
r addAColumn: c.
r openInWorld.! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
index

	^ index! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
index: anObject

	index := anObject! !

!WasmMemory methodsFor: 'as yet unclassified' stamp: 'edc 10/18/2018 07:24'!
initialize
	super initialize.
	map := Dictionary new.
wasm := OrderedCollection new.
	numTypes := 0.
	nunFunctions := 0.
	numExports := 0.
	numCodes := 0.
	numImports := 0.
	numDatas := 0.
	numGlobals := 0.
	index := 1! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 07:31'!
map
	^ map! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numCodes

	^ numCodes! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numCodes: anObject

	numCodes := anObject! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numDatas

	^ numDatas! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numDatas: anObject

	numDatas := anObject! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numExports

	^ numExports! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numExports: anObject

	numExports := anObject! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numGlobals

	^ numGlobals! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numGlobals: anObject

	numGlobals := anObject! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numImports

	^ numImports! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numImports: anObject

	numImports := anObject! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numTypes

	^ numTypes! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
numTypes: anObject

	numTypes := anObject! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
nunFunctions

	^ nunFunctions! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
nunFunctions: anObject

	nunFunctions := anObject! !

!WasmMemory methodsFor: 'as yet unclassified' stamp: 'edc 12/9/2018 07:46'!
show
	| r address f |
self helper.
	r := AlignmentMorphBob1 new borderWidth: 8;
				 borderColor: Color black;
				 color: Color white.
	address := 0.
	[f := OrderedCollection new.
	1 + address
		to: 15 + address
		do: [:i | i < self wasm size
				ifTrue: [f
						add: (self wasm at: i)]].
	r addARow: f.
	address + 14 < self wasm size]
		whileTrue: [address := address + 14].

	r topLeft: 20 @ 100.
	r openInWorld! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 07:21'!
wasm
	^ wasm ifNil:[wasm := OrderedCollection new]! !

!WasmMemory methodsFor: 'accessing' stamp: 'edc 10/18/2018 06:46'!
wasm: anObject

	wasm := anObject! !

Object subclass: #WastCompilerToWasm
	instanceVariableNames: 'wasm numTypes numExports numCodes numImports numDatas numGlobals index fileName inputLines line funcSignature funcNames funcWhichSignature localIndex wasmMorph byte globalNames callNames blockNames loopNames originalLine localNames functionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WASM'!

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 6/2/2018 09:25'!
arithmetic
^'nothing'! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 8/24/2019 05:28'!
blockNames
	^ blockNames
		ifNil: [blockNames := OrderedCollection new]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 5/16/2019 08:41'!
brNames
	^ brNames
		ifNil: [brNames := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 10/1/2019 07:39'!
brTable
| table order |

table := OrderedCollection new.
table add:(self blockNames size -1).
2 to: line size do:[:i| order := (self blockNames indexOf:(line at:i) ifAbsent:[0]) .
table add: order
].
^table
! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 6/1/2018 10:36'!
branch
self halt! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 3/21/2019 15:51'!
call
	| v word |

	word := line last.
	word isAllDigits
		ifTrue: [v := word asNumber
			"work for values < 255"]
		ifFalse: [byte first = 17
				ifTrue: [v := funcSignature keyAtValue: word.
					^ Array with: v with: 0]
				ifFalse: [v := self functionIndex
								keyAtValue: word
								ifAbsent: [].
					v
						ifNil: [v := funcNames
										keyAtValue: word
										ifAbsent: [self halt].
							v := v + functionIndex size]]
			].^ Array with: v! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 2/6/2019 09:56'!
callNames
	^ callNames
		ifNil: [callNames := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'verify' stamp: 'edc 10/24/2019 08:26'!
check
	| outWasm part f exit t cheka test val |
	outWasm := OrderedCollection new.
	
	t := 0.
	MVP1Spec sectionNames
		do: [:section | 
			part := self wasm
						at: section
						ifAbsent: [].
			part isEmptyOrNil
				ifFalse: [Transcript show: section;
						 show: '   start at: ';
						 show: t;
						 cr.
					t := t + part size.
					outWasm := outWasm , part]].
	f := (FileStream forceNewFileNamed: 'test.' , fileName , '.wasm') binary.
	1
		to: outWasm size
		do: [:i | 
			val := outWasm at: i.
			val > 255
				ifTrue: [cheka := outWasm copyFrom: 1 to: i.
					test := WasmForensics new.
					test wasm: cheka.
					test processWasm].
			val
				ifNotNil: [f nextPut: val]].
	f close.
	exit := WasmForensics compareWasm: 'wabt' , FileDirectory slash , fileName , '.wasm' with: 'test.' , fileName , '.wasm'.
	exit = outWasm size
		ifTrue: [^ Transcript show: 'SUCESS']
		ifFalse: [Transcript show: 'FALLA'.
			self halt.
			cheka := outWasm copyFrom: 1 to: exit.
			test := WasmForensics new.
			test wasm: cheka.
			test processWasm.
			Transcript show: String cr.
			part := 0.
			MVP1Spec sectionNames
				do: [:section | 
					t := self wasm
								at: section
								ifAbsent: [0].
					t = 0
						ifFalse: [part := part + t size.
							exit > part
								ifTrue: [Transcript show: section.
									Transcript show: '    ends to position '.
									Transcript show: part;
										 cr]
								ifFalse: [Transcript show: ' Found error in ' , section.
									self halt.
									(self wasm at: section) testSection]]]]! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 10/2/2019 11:10'!
comparison
	| word v |
	
	(byte first between: 69 and: 78)
		ifFalse: [^ 'nothing'].
	self readNewLine: true.
	line first = 'br_if'
		ifTrue: [word := line at: 2.
			(word at: 2)
					= $B
				ifTrue: [v := 1].
			(word at: 2)
					= $L
				ifTrue: [v := 0].
			^ Array with:13 with: v]
		ifFalse: [index := index - 1.
			^ 'nothing']! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 10/4/2019 08:37'!
comparisonKind
	| word v |
	word := line at: 2.
	(word at: 2)
			= $B
		ifTrue: [v := 0].
	(word at: 2)
			= $L
		ifTrue: [v := 0].
	^ v! !

!WastCompilerToWasm methodsFor: 'postProcessing' stamp: 'edc 5/1/2019 08:47'!
completeCode
	| toGrow t head |
	toGrow := self wasm
				at: 'code'
				ifAbsent: [self halt].
	toGrow addFirst: numCodes.
	t := toGrow size.


head := self readUnsignedLEB128: t.
	head addFirst: 10.
	self wasm at: 'code' put: head , toGrow! !

!WastCompilerToWasm methodsFor: 'postProcessing' stamp: 'edc 6/8/2019 11:05'!
completeData
	| toGrow t head |
	toGrow := self wasm
				at: 'data'
				ifAbsent: [self halt].
	numDatas > 0
		ifTrue: [toGrow addFirst: numDatas.
			t := toGrow size.

			head := self readUnsignedLEB128: t.
			head addFirst: 11.
			self wasm at: 'data' put: head , toGrow]! !

!WastCompilerToWasm methodsFor: 'postProcessing' stamp: 'edc 2/23/2019 08:59'!
completeExport
	| toGrow t head |
	toGrow := self wasm
				at: 'export'
				ifAbsent: [self halt].
	toGrow addFirst: numExports.
	t := toGrow size.

	head := self readUnsignedLEB128: t.
			head addFirst: 7.
			self wasm at: 'export' put: head , toGrow ! !

!WastCompilerToWasm methodsFor: 'postProcessing' stamp: 'edc 4/3/2019 10:48'!
completeFunc
	| toGrow inter |
	toGrow := self wasm
				at: 'func'
				ifAbsent: [OrderedCollection new].
	funcNames
		valuesDo: [:val | 
			inter := funcWhichSignature at: val.
			toGrow
				add: (self funcSignature keyAtValue: inter ifAbsent:[0])
			"Here we need guess function n signature
			index"].
	toGrow addFirst: funcNames size.
	toGrow addFirst: toGrow size.
	toGrow addFirst: 3.
	self wasm at: 'func' put: toGrow! !

!WastCompilerToWasm methodsFor: 'postProcessing' stamp: 'edc 4/21/2018 07:11'!
completeGlobal
	| toGrow |
	toGrow := self wasm
				at: 'global'
				ifAbsent: [].
	toGrow isEmptyOrNil
		ifTrue: [Transcript show: 'No global section ';
				 cr.
			^ false].
	toGrow addFirst: numGlobals.
	toGrow addFirst: toGrow size.
	toGrow addFirst: 6.
	self wasm at: 'global' put: toGrow! !

!WastCompilerToWasm methodsFor: 'postProcessing' stamp: 'edc 2/23/2019 08:59'!
completeImport
	| toGrow t head|
	toGrow := self wasm
				at: 'import'
				ifAbsent: [^ false].
	toGrow addFirst: numImports.

t := toGrow size.

	head := self readUnsignedLEB128: t.
	head addFirst: 2.
	
	self wasm at: 'import' put: head , toGrow! !

!WastCompilerToWasm methodsFor: 'postProcessing' stamp: 'edc 3/21/2019 08:28'!
completeType
	| toGrow |
	toGrow := self wasm
				at: 'type'
				ifAbsent: [self halt].

	toGrow addFirst: numTypes.
	toGrow addFirst: toGrow size.
	toGrow addFirst: 1.
	self wasm at: 'type' put: toGrow! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 10/24/2019 08:39'!
control
	| word doNothing lindex v |
	doNothing := #(0 1 27 15 26 5).
	(doNothing includes: byte first)
		ifTrue: [^ 'nothing'].
	line first caseOf: {
		['br'] -> [^OrderedCollection with: self loopOrBlock].
		['nop'] -> [].
		['unreachable'] -> [].
		['br_table'] -> [].
		[' select'] -> [].
		['drop'] -> [].
		['else'] -> [^ 'nothing'].
		['br_if'] -> [^OrderedCollection with: self loopOrBlock].
		['return'] -> [].
		['loop'] -> 
			[self loopOrBlock.
			^ OrderedCollection with: 64].
		['block'] -> 
			[self loopOrBlock.
			^ OrderedCollection with: 64].
		['if'] -> 
			[lindex := line indexOf: 'result'.
			lindex > 0
				ifTrue: [word := line at: lindex + 1.
					v := (MVP1Spec types keyAtValue: word) asHexNumber]
				ifFalse: [v := 64].
			^ Array with: v]}
		 otherwise: [self halt]! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 10/31/2018 09:29'!
conversion
	^ 'nothing'! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 10/4/2019 17:13'!
depth: word
self halt.! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 4/30/2019 21:36'!
endProcessWast

	wasm
		keysDo: [:ea | (#('module' 'table' 'elem' 'memory' 'start' ) includes: ea)
				ifFalse: [Transcript show: 'Complete ' , ea asString;
						 cr.
					self perform: ('complete' , ea capitalized) asSymbol]].
	self completeFunc.
	self check! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/22/2018 09:41'!
funcNames
	^ funcNames
		ifNil: [funcNames := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 12:38'!
funcSignature
	^ funcSignature
		ifNil: [funcSignature := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/21/2018 07:02'!
funcWhichSignature
^funcWhichSignature ifNil:[funcWhichSignature := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 2/22/2019 09:45'!
functionIndex
	^ functionIndex
		ifNil: [functionIndex := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 2/3/2019 12:27'!
globalNames

	^ globalNames ifNil:[globalNames := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 10/16/2019 18:13'!
guessIfmixedNumberAndString
	| s s2  |
	
	
	originalLine
		ifNotNil: [(originalLine indexOf: $\)> 0 ifFalse:[^true].
			s2 := OrderedCollection new.
			
			s := originalLine findTokens: '\']ifNil:[^false].
	s
		do: [:ea | 
		ea size > 2
						ifTrue: [s2
						add: (ea copyFrom: 1 to: 2).
							s2
						add:(ea copyFrom: 3 to: ea size)]
						ifFalse: [s2 add: ea]].
			.
originalLine := s2.

	^true! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 2/16/2019 07:53'!
guessKind
| lindex kind  word|
kind := 1.
lindex := 0.
word :=#('func' 'table' 'memory' 'global' ) .


[(lindex := line indexOf: (word at: kind)).

 lindex > 0] whileFalse:[kind :=  kind +1.].
^ Array with: kind - 1 with: lindex with: (word at:kind )

 
	! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 2/6/2019 06:09'!
howManyParams: aInteger 
	| section numParams lindex instruction |

	numParams := 0.
	section := OrderedCollection new.
	lindex := aInteger.
	[instruction := line at: lindex.

(instruction = 'param') ifFalse:[
	(instruction beginsWith: '$')
		ifTrue: [self storeLocalName: instruction]
		ifFalse: [byte := MVP1Spec types
						keyAtValue: instruction
						ifAbsent: [].
			byte
				ifNotNil: [byte := byte asHexNumber.
					section add: byte.
					numParams := numParams + 1]]].
	lindex := lindex + 1.
	byte isNil | (lindex > line size)] whileFalse.
	section addFirst: numParams.
	section addFirst: 96.
	^ section! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
index

	^ index! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
index: anObject

	index := anObject! !

!WastCompilerToWasm methodsFor: 'initialize-release' stamp: 'edc 2/19/2019 09:57'!
initialize
	wasm := Dictionary new.
	numTypes := 0.
	numExports := 0.
	numCodes := 0.
	numImports := 0.
	numDatas := 0.
	numGlobals := 0.
	index := 1.
	wasmMorph := OrderedCollection new.
	! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 2/23/2019 09:02'!
inmp: byte 
	"Means Instruction needs more processing"
	| value offset align section |
	section := OrderedCollection new.
	byte = 17
		ifTrue: [value := line at: 2.
			^ self readUnsignedLEB128: value].
	byte = 40
		ifTrue: [^ #(2 0 )].
	(byte between: 40 and: 43)
			| (byte between: 44 and: 48)
		ifTrue: [line size = 1
				ifTrue: [section add: 0.
					section add: 0.
					^ section].
			offset := line second findString: 'offset='.
			offset > 0
				ifTrue: [value := line second copyFrom: 8 to: line second size.
					section := section
								, (self readUnsignedLEB128: value)]
				ifFalse: [section add: 0].
			line size > 2
				ifTrue: [align := (line at: 3)
								findString: 'align='.
					align > 0
						ifTrue: [value := (line at: 3)
										copyFrom: 7
										to: (line at: 3) size.
							section := section
										, (self readSignedLEB128: value)]
						ifFalse: [section add: 0]]
				ifFalse: [section addFirst: 0].
			^ section].
	(byte between: 65 and: 68)
		ifTrue: [value := line at: 2.
			^ self readSignedLEB128: value]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 10:19'!
inputLines

	^ inputLines ifNil:[inputLines := OrderedCollection new]! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 10/22/2019 07:40'!
load
	| offset align r |
	offset := self scanWord: 'offset'.
	align := self scanWord: 'align'.
	offset := self readUnsignedLEB128: offset.
	line first caseOf: {
		['i32.load8_s'] -> [].
		['i32.load16_u'] -> [align caseOf: {
			[0] -> [align := 1].
			[1] -> [align := 0]}
			 otherwise: [self halt]].
		['i64.load'] -> [align := 3].
		['i32.load16_s'] -> [].
		['f64.load'] -> [].
		['i64.load8_s'] -> [].
		['i32.load8_u'] -> [].
		['i32.load'] -> [align caseOf: {
			[0] -> [align := 2].
			[1] -> [align := 0].
			[2] -> [align := 1]}
			 otherwise: [self halt]].
		['f32.load'] -> []}.
	r := OrderedCollection with: align.
	r := r , offset.
	^ r! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 6/1/2018 10:44'!
local
|word v|
word := line second.
			word isAllDigits
				ifTrue: [v := word asNumber].


^ Array with: v! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 2/3/2019 19:38'!
localIndex
	
	^ localIndex
		ifNil: [localIndex := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 2/4/2019 18:07'!
localNames
	^ localNames
		ifNil: [localNames := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 10/22/2019 07:52'!
loopNames
	^ loopNames
		ifNil: [loopNames := OrderedCollection  new]! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 11/1/2019 10:34'!
loopOrBlock
|letra|
line size = 1 ifTrue:[^ 'nothing' ].
letra := line last at: 2.
letra caseOf: {
	
			[$B] -> [^self solveBlockNames].
			[$L] -> [^self solveLoopNames]}
			 otherwise: [self halt].! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 10/19/2019 10:52'!
memory
	| offset align r |
	offset := self scanWord: 'offset'.
	line first caseOf: {
		['i32.store16'] -> [align := 1].
		['i64.store32'] -> [align := 2].
		['i64.store16'] -> [align := 1].
		['i64.store8'] -> [align := 0].
		['i64.store'] -> 
			[align := 3].
		['f64.store'] -> [align := 3].
		['f32.store'] -> [align := 2].
		['i32.store8'] -> [align := 0].
		['i32.store'] -> [align := 2]}
		 otherwise: [self halt].
	offset := self readUnsignedLEB128: offset.
	r := OrderedCollection with: align.
	r := r , offset.
	^ r! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 5/16/2019 08:00'!
memoryNames
	^ memoryNames
		ifNil: [memoryNames := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/8/2019 07:13'!
moreData
	| end s|
s := String new.
	[index <= inputLines size]
		whileTrue: [end := self readNewLine2: true.

			end
				ifFalse: [s := s,originalLine]].
originalLine := s.
self guessIfmixedNumberAndString! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 5/15/2018 12:10'!
moreProcessing
	| sectionNames word |
	sectionNames := MVP1Spec sectionNames.
	word := line first.
	word = 'func'
		ifTrue: [self storeCode]
		ifFalse: [
			(sectionNames includes: word)
				ifTrue: [self perform: ('store' , word capitalized) asSymbol]]! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numDatas

	^ numDatas! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numDatas: anObject

	numDatas := anObject! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numExports

	^ numExports! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numExports: anObject

	numExports := anObject! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numGlobals

	^ numGlobals! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numGlobals: anObject

	numGlobals := anObject! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numImports

	^ numImports! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numImports: anObject

	numImports := anObject! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numTypes

	^ numTypes! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
numTypes: anObject

	numTypes := anObject! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
nunFunctions

	^ nunFunctions! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
nunFunctions: anObject

	nunFunctions := anObject! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 2/27/2019 07:44'!
operation
^#(0)! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 2/5/2019 07:12'!
paramNames
	^ paramNames
		ifNil: [paramNames := Dictionary new]! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/8/2019 10:54'!
preProcess
	| word g end |
	[index <= inputLines size]
		whileTrue: [end := self readNewLine: false.
			end
				ifFalse: [word := line first.

					word = 'func'
						ifTrue: [self
								storeFuncNames: (line at: 2).
							self
								storefuncWhichSignature: (line at: 2)].
					word := line first.
word = 'data'
						ifTrue: [self storeData].
					word = 'global'
						ifTrue: [self storeGlobalName].
					word = 'import'
						ifTrue: [g := line indexOf: 'global'.
							g > 0
								ifTrue: [self
										storeGlobalName: (line at: g + 1)].
							g := line indexOf: 'func'.
							g > 0
								ifTrue: [self
										storeFuncIndex: (line at: g + 1).
									self
										storefuncWhichSignature: (line at: g + 1)]]]].
	index := 1! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 10/18/2019 16:03'!
processData
	| section s t head |
	section := OrderedCollection new.

	s := self guessIfmixedNumberAndString.
	s
		ifFalse: [self moreData].
		(originalLine isKindOf: OrderedCollection) ifFalse:[originalLine size > 2
		ifTrue: [originalLine
				do: [:ch | section add: ch asciiValue]]].
	
	originalLine
				do: [:ea | ea isHexNumber & (ea size = 2)
						ifTrue: [section add: ea asHexNumber]
						ifFalse: [ea
								do: [:ch | section add: ch asciiValue]]].
	t := section size.
	head := LEB128 encodeUnsignedLEB: t.
	section := head , section.
	^ section! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/8/2019 11:03'!
processWast
	| sectionNames word end |
	self preProcess.
	sectionNames := MVP1Spec sectionNames.
	[index <= inputLines size]
		whileTrue: [end := self readNewLine: true.
			end
				ifFalse: [word := line first.
word = 'data' 	ifFalse: [
					word = 'func'
						ifTrue: [self storeCode.
]
						ifFalse: [(sectionNames includes: word)
								ifTrue: [self perform: ('store' , word capitalized) asSymbol]]]]].

	
	self endProcessWast! !

!WastCompilerToWasm methodsFor: 'verify' stamp: 'edc 2/2/2019 07:56'!
quickTest
	| word numFunctions test|
	numFunctions := 0.
	[index <= inputLines size]
		whileTrue: [self readNewLine: true.
			word := line first.
			word = 'func'
				ifTrue: [numFunctions := numFunctions + 1]].
test :=WasmForensics new testQuick! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/9/2019 10:28'!
readFloat: aString

^aString asNumber asFloat f64
! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/8/2019 10:43'!
readNewLine2: aBoolean 
	| lindex lindex2 |
	index <= inputLines size
		ifFalse: [^ true].
	line := inputLines at: index.
	aBoolean
		ifTrue: [Transcript show: line;
				 cr].
	
	line
		ifEmpty: [index := index + 1.
			^ self readNewLine2: aBoolean]
		ifNotEmpty: [lindex := line indexOf: $".
			lindex > 0
				ifTrue: [lindex2 := line indexOf: $" startingAt: lindex + 1.
					originalLine := line copyFrom: lindex + 1 to: lindex2 - 1]
				ifFalse: [originalLine := nil]].
	line := line splitBy: ' '.
	index := index + 1.
	^ false! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/11/2019 06:38'!
readNewLine: aBoolean 
	| lindex lindex2 |
	index <= inputLines size
		ifFalse: [^ true].
	line := inputLines at: index.

	line := line withoutParentesis.
	aBoolean
		ifTrue: [Transcript show: line;
				 cr].
	line
		ifEmpty: [index := index + 1.
			^ self readNewLine: aBoolean]
		ifNotEmpty: [line last = $"
				ifTrue: [lindex := line indexOf: $".
					lindex > 0
						ifTrue: [lindex2 := line indexOf: $" startingAt: lindex + 1.
							originalLine := line copyFrom: lindex + 1 to: lindex2 - 1]
						ifFalse: [originalLine := nil]].
			line := line splitBy: ' '.
			index := index + 1].
	^ false! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 2/26/2019 07:35'!
readUnsignedLEB128: v 

^LEB128 encodeUnsignedLEB: v asNumber
	! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/8/2019 10:49'!
readWast: aStream 
	| l comment |
	fileName := (aStream name splitBy: FileDirectory slash) last.
	fileName := (fileName splitBy: '.') first.
	[aStream atEnd]
		whileFalse: [l := aStream nextLine withBlanksTrimmed.
			comment := l findString: ';;'.
			comment > 0
				ifTrue: [l := l copyFrom: 1 to: comment - 1].
			self inputLines add: l.
].

	WasmLogger open.
	WasmLogger filename: fileName , '.txt'.
	self processWast! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 10/18/2019 06:33'!
scanWord: aString
|value|
2
		to: line size
		do: [:lindex | 
			((line at: lindex)
					beginsWith: aString)
				ifTrue: [value := ((line at: lindex)
								findTokens: '=') last.
					value := value asNumber]
				].
			value ifNil:[value :=0].
				^value! !

!WastCompilerToWasm methodsFor: 'verify' stamp: 'edc 10/14/2018 07:34'!
seeMemory
	| part s outWasm|
outWasm := OrderedCollection new.
	MVP1Spec sectionNames
		do: [:section | 
			part := self wasm
						at: section
						ifAbsent: [].
			part isEmptyOrNil
				ifFalse: [Transcript show: section;
						 tab.
					outWasm := outWasm , part.
part do:[:mem| s := mem hex fill2zero asLowercase.
Transcript show: s;
						 tab.].
Transcript show: String cr.
self halt.
]].


! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 8/24/2019 05:40'!
solveBlock
self blockNames addFirst: line last.
! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 10/23/2019 10:41'!
solveBlockNames


	| fword |
	fword := line last.
	
	(fword beginsWith: '$')
		ifTrue: [(self blockNames includes: fword)
				ifTrue: [^ (loopNames indexOf: fword)
						]
				ifFalse: [self blockNames add: line last].
			^ (blockNames indexOf: fword)
				]
	! !

!WastCompilerToWasm methodsFor: 'signatures' stamp: 'edc 5/3/2018 17:45'!
solveGlobalNames
line last isAllDigits ifTrue:[^line last asNumber].
self halt.! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 10/23/2019 21:17'!
solveLoopNames
	| fword |
	fword := line last.
	
	(fword beginsWith: '$')
		ifTrue: [(self loopNames includes: fword)
				ifTrue: [^ (loopNames indexOf: fword)
						]
				ifFalse: [loopNames add: fword].
			^ (loopNames indexOf: fword)
				]! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 5/16/2019 08:01'!
solveMemoryNames
	| keyIndex |
	line
		do: [:fword | (fword beginsWith: '$')
				ifTrue: [(self memoryNames values includes: fword)
						ifTrue: [^ memoryNames keyAtValue: fword]
						ifFalse: [keyIndex := memoryNames size.
							memoryNames at: keyIndex put: fword].
					^ keyIndex]]! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 5/16/2019 08:50'!
solvebrName
	|  word|


word := line last.
			(self brNames values includes: word)
ifTrue:[

^self brNames keyAtValue: word]
				ifFalse: [self halt].

	! !

!WastCompilerToWasm methodsFor: 'signatures' stamp: 'edc 5/5/2018 09:38'!
solvefuncSignature
	| word |
	word := line last.

	^funcSignature keyAtValue: word! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 2/21/2019 08:20'!
solvefunctionIndex: word 
	| functionIndex |
	functionIndex := self functionIndex indexOf: word.
	functionIndex > 0
		ifTrue: [^ functionIndex - 1].
^-1! !

!WastCompilerToWasm methodsFor: 'opcode Category' stamp: 'edc 10/19/2019 11:01'!
special
	| word |
	byte first = 67
		ifTrue: [^ line second asF32Wasm].
	word := line last.
	(( byte first = 65)|(byte first = 66))
		ifTrue: [^ LEB128 readSignedLEB128: line second].
	byte first = 35
		ifTrue: [(globalNames values includes: word)
				ifTrue: [^ OrderedCollection
						with: (globalNames keyAtValue: word)]
				ifFalse: [self halt]].
	byte first = 68
		ifTrue: [^ self readFloat: line second].
	(byte first between: 32 and: 34)
		ifTrue: [(localNames values includes: word)
				ifTrue: [^ OrderedCollection
						with: (localNames keyAtValue: word)]
				ifFalse: [word isAllDigits
						ifTrue: [^ LEB128 readSignedLEB128: word]]].
	word isAllDigits
			| (word beginsWith: '-')
		ifTrue: [^ self readUnsignedLEB128: word]
		ifFalse: [self storeGlobalName: word.
			^ OrderedCollection
				with: (globalNames keyAtValue: word)]! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/1/2018 10:36'!
store
self halt! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 10/22/2019 08:04'!
storeCode
	| section toGrow word end part if ldc sectionNames head |
	if := 1.
	ldc := 0.
	sectionNames := MVP1Spec sectionNames.
	loopNames := OrderedCollection new.
	self storeFunction.
	toGrow := self wasm
				at: 'code'
				ifAbsent: [self wasm at: 'code' put: OrderedCollection new].
	section := OrderedCollection new.
	end := false.
	[end]
		whileFalse: [index > inputLines size
				ifTrue: [end := true]
				ifFalse: [self readNewLine: true.
					word := line first.
					word = 'func'
						ifTrue: [self storeFunction].
					(sectionNames includes: word)
						ifTrue: [section add: 11.
							end := true.
							if := if - 1]
						ifFalse: [word caseOf: {
								['end'] -> 
									[section add: 11.
									if := if - 1].
								['local'] -> 
									[part := self storeLocal.
									ldc := 1.
									section := section , part]}
								 otherwise: 
									[byte := MVP1Spec opcodesDelJson at: word.
									section add: byte first.
									part := self perform: byte last.
									part = 'nothing'
										ifFalse: [section := section , part]]]]].
	numCodes := numCodes + 1.
	"0b end"
	"now guessing pending end not in text"
	if
		timesRepeat: [section add: 11].
	ldc = 0
		ifTrue: [section addFirst: ldc].
	head := LEB128 encodeUnsignedLEB: section size.
	toGrow := toGrow , head , section.
	self wasm at: 'code' put: toGrow.
	self moreProcessing! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 10/16/2019 17:29'!
storeData
	"Right now we recognize ascii data or hexa data
	del brainfuck
	(data (i32.const 5440)
	/checkout/src/libcore/option.rs
	)
	(data (i32.const 5472)
	\c0\15\00\00 \00\00\00\e0\15\00\00\12\00\00\00
	)"
	| section toGrow instruction part value |

	toGrow := self wasm
				at: 'data'
				ifAbsent: [OrderedCollection new].
	numDatas := numDatas + 1.
	section := OrderedCollection new.
	section add: 0.
	instruction := line second.
	byte := MVP1Spec opcodesDelJson
				at: instruction
				ifAbsent: [].
	byte
		ifNotNil: [section add: byte first.
			value := line at: 3.
			(value beginsWith: '$')
				ifTrue: [value := globalNames
								keyAtValue: (line at: 3)]
				ifFalse: [value := (line at: 3) asInteger.
					part := LEB128 readSignedLEB128: value.
					section := section , part]].
	section add: 11.
	"0b end"
	"memory index"
	part := self processData.
	section := section , part.
	toGrow := toGrow , section.
	self wasm at: 'data' put: toGrow! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/23/2019 09:00'!
storeElem
	| section instruction end tailSection numFunctionIndices v word|
	numFunctionIndices := 0.
	section := OrderedCollection new.
	tailSection := OrderedCollection new.
	section add: 1.
	"num elements 1 for now"
	section add: 0.
	"table index"
	instruction := line second.
	byte := MVP1Spec opcodesDelJson
				at: instruction
				ifAbsent: [end := true].
	byte := byte first.

	byte = true
		ifFalse: [section add: byte.
			"check for call insgruction"
			byte = 35
				ifTrue: [section
						add: (self globalNames
								keyAtValue: (line at: 3))].
			byte = 16
				ifTrue: [section add: self exportfuncindex].
			byte = 32
				ifTrue: [section add: localIndex.
					localIndex := localIndex + 1].
			(byte between: 65 and: 68)
				ifTrue: [v := self
								readUnsignedLEB128: (line at: 3).
					section := section , v]].
	section add: 11.
	"0b end"

	4
		to: line size
		do: [:ea | word := (line at: ea).

			(word
					beginsWith: '$')
				ifTrue: [v := self globalNames
								keyAtValue: word ifAbsent:[].
v ifNil:[v :=  funcNames keyAtValue: word].


					tailSection add: v + functionIndex size]
				ifFalse: [tailSection add: (line at: ea) asNumber].

			numFunctionIndices := numFunctionIndices + 1].


	tailSection addFirst: numFunctionIndices.
	section := section , tailSection.
	section addFirst: section size.
	section addFirst: 9.
	self wasm at: 'elem' put: section.
	^ false! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 10/15/2019 07:33'!
storeExport
	| section toGrow s kind lindex itemIndex word fn |
	numExports := numExports + 1.
	toGrow := self wasm
				at: 'export'
				ifAbsent: [OrderedCollection new].
	section := OrderedCollection new.
	lindex := line
				indexOf: 'export'
				ifAbsent: [self halt].
	lindex := lindex + 1.
	s := (line at: lindex)
				copyFrom: 2
				to: (line at: lindex) size - 1.
	section add: s size.
	s
		do: [:ch | section add: ch asciiValue].
	kind := self guessKind.
	section
		add: (kind at: 1).
		
	kind last = 'func'
		ifTrue: ["Must guess import signature index"
			word := line at: (kind at: 2)
							+ 1.
			word isAllDigits
				ifTrue: [itemIndex := word asNumber]
				ifFalse: [functionIndex
						ifNil: [itemIndex := funcNames
										keyAtValue: word
										ifAbsent: [self halt]]
						ifNotNil: [itemIndex := functionIndex
										keyAtValue: word
										ifAbsent: [fn := funcNames
														keyAtValue: word
														ifAbsent: [self halt].
											itemIndex := functionIndex size + fn]]].
			section add: itemIndex]
		ifFalse: [section add: line last asNumber].
	toGrow := toGrow , section.
	self wasm at: 'export' put: toGrow! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/22/2019 09:43'!
storeFuncIndex: word 
	| keyIndex |
	(self functionIndex values includes: word)
		ifFalse: [keyIndex := functionIndex size.
			functionIndex at: keyIndex put: word]! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/21/2019 09:08'!
storeFuncNames:word
	|   keyIndex |
	
	(self funcNames values includes: word)
		ifFalse: [keyIndex := funcNames size.
			funcNames at: keyIndex put: word].
	! !

!WastCompilerToWasm methodsFor: 'signatures' stamp: 'edc 4/3/2019 10:53'!
storeFuncSignature
	| keyIndex lindex word |

	lindex := line
				indexOf: 'type'
				ifAbsent: [^0].
	lindex > 0
		ifTrue: [word := line at: lindex + 1.
			word := (word findTokens: ';') first.
			(self funcSignature values includes: word)
				ifTrue: [^ funcSignature keyAtValue: word]
				ifFalse: [keyIndex := funcSignature size.
					funcSignature at: keyIndex put: word]]! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/22/2019 09:41'!
storeFunction
	| section lindex |
	localNames := Dictionary new.
	section := OrderedCollection new.
	
	
	section add: 96.
	lindex := line
				indexOf: 'param'
				ifAbsent: [0].
	lindex > 0
		ifTrue: [section := section , section
						add: (self howManyParams: lindex + 1)]
		ifFalse: [section add: 0].
	lindex := line
				indexOf: 'result'
				ifAbsent: [0].
	lindex > 0
		ifTrue: [byte := MVP1Spec types
						keyAtValue: (line at: lindex + 1)
						ifAbsent: [].
			byte
				ifNil: [section add: 0]
				ifNotNil: [byte := byte asHexNumber.
					section add: 1.
					section add: byte]]
		ifFalse: [section add: 0].
	
	^ section! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 11/9/2019 07:44'!
storeGlobal
	| section globalMutability toGrow instruction lindex isNumber r word part |

	toGrow := self wasm
				at: 'global'
				ifAbsent: [self wasm at: 'global' put: OrderedCollection new].
	section := OrderedCollection new.
	(line second beginsWith: '$')
		ifTrue: [self storeGlobalName: line second.
			isNumber := false]
		ifFalse: [isNumber := true].
	lindex := line
				indexOf: 'mut'
				ifAbsent: [0].
	lindex > 0
		ifTrue: [globalMutability := 1.
			lindex := 4]
		ifFalse: [globalMutability := 0.
			lindex := 3].
	instruction := line at: lindex.
	section add: (MVP1Spec types keyAtValue: instruction) asHexNumber.
	section add: globalMutability.
	lindex := lindex + 1.
	instruction := instruction := line at: lindex.
	byte := WasmForensics opcodesDelJson
				at: instruction
				ifAbsent: [].
	byte
		ifNotNil: [section add: byte].
	lindex := lindex + 1.
	word := line at: lindex.
	(word beginsWith: '$')
		ifTrue: [r := globalNames
						keyAtValue: (line at: lindex).
			section add: r]
		ifFalse: [instruction caseOf: {
				['f32.const'] -> [section := section , word asF32Wasm].
			['f64.const'] -> [self halt].
			['i64.const'] -> 
					[part := LEB128 readSignedLEB128: word.
					section := section , part].
				['i32.const'] -> 
					[part := LEB128 readSignedLEB128: word.
					section := section , part]}
				 otherwise: [self halt]].
	section add: 11.
	"0b end"
	toGrow := toGrow , section.
	self wasm at: 'global' put: toGrow.
	numGlobals := numGlobals + 1! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/3/2019 12:33'!
storeGlobalName
	| lindex word keyIndex|

	lindex := line
				indexOf: 'global'
				ifAbsent: [self halt.].
word := line at: lindex + 1.
			(self globalNames values includes: word)
				ifFalse: [keyIndex := globalNames size.
					globalNames at: keyIndex put: word].
^globalNames keyAtValue: word
	! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/4/2019 04:22'!
storeGlobalName:word
	|   keyIndex |
	
	(self globalNames values includes: word)
		ifFalse: [keyIndex := globalNames size.
			globalNames at: keyIndex put: word].
	^ globalNames keyAtValue: word! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 11/9/2019 07:56'!
storeImport
	| section s kind toGrow lindex word v part globalMutability |
	toGrow := self wasm
				at: 'import'
				ifAbsent: [OrderedCollection new].
	section := OrderedCollection new.
	lindex := line
				indexOf: 'import'
				ifAbsent: [0].
	lindex > 0
		ifFalse: [self halt].
	2
		timesRepeat: [word := line at: lindex + 1.
			lindex := lindex + 1.
			s := word copyFrom: 2 to: word size - 1.
			section add: s size.
			s
				do: [:ch | section add: ch asciiValue]].
	
	kind := self guessKind.
	section add: kind first.
	kind last caseOf: {
		['func'] -> 
			[v := self storeFuncSignature.
			v
				ifNil: [self halt]
				ifNotNil: [section add: v]].
		['table'] -> 
			[part := self
						storeImport2: (kind at: 2).
			part addFirst: 112.
			"'anyfunc"
			section := section , part].
		['memory'] -> 
			[part := self storeImport2: kind second.
			section := section , part].
		['global'] -> 
			[v := MVP1Spec types
						keyAtValue: line last
						ifAbsent: [].
			"here check type of global"
			v
				ifNil: [self halt]
				ifNotNil: [section add: v asHexNumber].
			globalMutability := line
						indexOf: 'mut'
						ifAbsent: [0].
			globalMutability > 0
				ifTrue: [globalMutability := 1].
			section add: globalMutability]}.
	toGrow := toGrow , section.
	numImports := numImports + 1.
	self wasm at: 'import' put: toGrow! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 6/9/2019 08:54'!
storeImport2: lindex
| flags limIn linMax section v word|

v := lindex +2.
word :=line at: v.
section := OrderedCollection new.

		
			(word
					withoutAny: $;) isAllDigits
				ifTrue: [
					limIn := self readUnsignedLEB128: word asNumber.
					flags := 0.].
(v = line size ) ifFalse:[
			v := v + 1.
			((line at: v)
					withoutAny: $;) isAllDigits
				ifTrue: [linMax := self readUnsignedLEB128: (line at: v) asNumber.
					flags := 1]].
section add: flags.
					section := section , limIn .
flags = 1 ifTrue:[section := section ,linMax]
.
^section! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 5/1/2019 10:33'!
storeLocal
	| section count values thisByte thisValue t|

	section := OrderedCollection new.
	values := OrderedCollection new.
	line
		do: [:ea | (ea beginsWith: '$')
				ifTrue: [self storeLocalName: ea]
				ifFalse: [byte := MVP1Spec types
								keyAtValue: ea
								ifAbsent: [].
					byte notNil
						ifTrue: [values add: byte asHexNumber]]].


thisValue := values first.
t := 1.
	count := 1.
	2
		to: values size
		do: [:i |thisByte := values at: i.
thisValue = thisByte ifTrue:[count := count + 1]
ifFalse:[section add:count.
section add: thisValue.count := 1.
thisValue := thisByte.
t := t +1.

 ]].

section add:count.
section add: thisValue.
section addFirst: t.
	^ section! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/5/2019 07:40'!
storeLocalName: word 
	| keyIndex |
	(self localNames values includes: word)
		ifFalse: [keyIndex := localNames size.
			localNames at: keyIndex put: word].
	^ localNames keyAtValue: word! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 10/15/2019 07:42'!
storeMemory
	"we guess only one memory and limits: flags
	is zero and limits: initial is provided in last
	part of
	line"
	| section part |
	
( line
				indexOf: 'export' )> 0 ifTrue:[
					self storeExport].
	
	section := OrderedCollection new.
	section add: 1.
	part := self storeTM.
	part size = 1
		ifTrue: [section add: 0]
		ifFalse: [section add: 1].
	section := section , part.
	section addFirst: section size.
	section addFirst: 5.
	self wasm at: 'memory' put: section! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 1/18/2019 05:35'!
storeModule
	self wasm at: 'module' put: MVP1Spec module! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 2/27/2019 07:51'!
storeStart
	"For now we suppos elementary start section"
	| section |
	section := OrderedCollection new.
	section add: 8.
	section add: 1.
(line second beginsWith: '$')
		ifTrue: [section add: (funcNames  keyAtValue: (line second))]
	ifFalse: [section add: line last asNumber].
	self wasm at: 'start' put: section! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 10/15/2019 07:35'!
storeTM
	| section position|
	section := OrderedCollection new.
	position := line size -1.
	((line at: position)
			withoutAny: $;) isAllDigits
		ifTrue: [section add: (line at: position) asNumber].
	line size >= 3
		ifTrue: [position := position +1.
			((line at: position)
			withoutAny: $;) isAllDigits
		ifTrue: [section add: (line at: position) asNumber]].
	^ section! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 6/7/2018 06:43'!
storeTable
	"We guess only one table is present 
	
	Table Description
	Field Name Type Description
	element_type table element type the element
	type of the table
	resizable resizable limits table flags and sizes in
	units of elements
	
	Validation:
	
	The element_type is required to be anyfunc
	"
	| section check part|
	check := line last = 'anyfunc'.
	check
		ifFalse: [self halt].
	section := OrderedCollection new.
	section add: 1.
	section add: 112.
	part := self storeTM.
	part size = 1
		ifTrue: [section add: 0]
		ifFalse: [section add: 1].
	section := section , part.


	section addFirst: section size.
	section addFirst: 4.
	self wasm at: 'table' put: section! !

!WastCompilerToWasm methodsFor: 'sections' stamp: 'edc 1/25/2019 10:01'!
storeType
	| toGrow section lindex   |
	
	
	toGrow := self wasm
				at: 'type'
				ifAbsent: [OrderedCollection new].
	numTypes := numTypes + 1.
	section := OrderedCollection new.
	section add: 96.
	lindex := line
				indexOf: 'param'
				ifAbsent: [0].
	lindex > 0
		ifTrue: [section := section , section
						add: (self howManyParams: lindex + 1)]
		ifFalse: [section add: 0].
	lindex := line
				indexOf: 'result'
				ifAbsent: [0].
	lindex > 0
		ifTrue: [byte := MVP1Spec types
						keyAtValue: (line at: lindex + 1)
						ifAbsent: [].
			byte
				ifNil: [section add: 0]
				ifNotNil: [byte := byte asHexNumber.
					section add: 1.
					section add: byte]]
		ifFalse: [section add: 0].
	self wasm at: 'type' put: toGrow , section.
	self storeFuncSignature! !

!WastCompilerToWasm methodsFor: 'signatures' stamp: 'edc 2/27/2019 07:19'!
storefuncWhichSignature:fword
	| lindex tword |

	lindex := line
				indexOf: 'type'
				ifAbsent: [0].
	lindex = 0
		ifTrue: [tword :=0]
		ifFalse: [tword := line at: lindex + 1].
	self funcWhichSignature at: fword put: tword! !

!WastCompilerToWasm methodsFor: 'processing' stamp: 'edc 5/29/2018 19:30'!
storelocalIndex
	| keyIndex |

	(self localIndex values includes: line second)
		ifTrue: [^ localIndex keyAtValue: line second]
		ifFalse: [keyIndex := localIndex size.
			localIndex at: keyIndex put: line second].
	^ localIndex keyAtValue: line second! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
wasm

	^ wasm! !

!WastCompilerToWasm methodsFor: 'accessing' stamp: 'edc 4/20/2018 11:12'!
wasm: anObject

	wasm := anObject! !

!OrderedCollection methodsFor: '*WASM' stamp: 'edc 6/7/2019 09:18'!
hex
| instance|
instance := OrderedCollection new.
self pairsDo:[:ea :ea2| instance add: ea hex fill2zero asLowercase,ea2 hex fill2zero asLowercase].
^instance
! !

!OrderedCollection methodsFor: '*WASM' stamp: 'edc 5/1/2019 08:36'!
testBadByte
1 to: self size do:[:index | (self at: index) > 255 ifTrue:[^index] ].
^false! !

!OrderedCollection methodsFor: '*WASM' stamp: 'edc 12/8/2018 07:59'!
testQuick
WasmForensics testQuick:  self! !

!OrderedCollection methodsFor: '*WASM' stamp: 'edc 10/2/2019 10:12'!
testSection

WasmForensics testSection: MVP1Spec module ,self! !

!Number class methodsFor: '*WASM' stamp: 'edc 6/8/2019 10:33'!
readFrom: stringOrStream 
	"Answer a number as described on aStream.  The number may
	include a leading radix specification, as in 16rFADE"
	| value base aStream sign |
	aStream _ (stringOrStream isMemberOf: String)| (stringOrStream isMemberOf:ByteString)
		ifTrue: [ReadStream on: stringOrStream]
		ifFalse: [stringOrStream].
	(aStream nextMatchAll: 'NaN') ifTrue: [^ Float nan].
	sign _ (aStream peekFor: $-) ifTrue: [-1] ifFalse: [1].
	(aStream nextMatchAll: 'Infinity') ifTrue: [^ Float infinity * sign].
	base _ 10.
	value _ Integer readFrom: aStream base: base.
	(aStream peekFor: $r)
		ifTrue: [
			"<base>r<integer>"
			(base _ value) < 2 ifTrue: [
				base = 1 ifTrue: [ ^Integer readBaseOneFrom: aStream ].
				^self error: 'Invalid radix'].
			(aStream peekFor: $-) ifTrue: [sign _ sign negated].
			value _ Integer readFrom: aStream base: base].
	(aStream peekFor: $x)
		ifTrue: [
			"0x<integer>" "Hexadecimal"
			base _ 16.
			(aStream peekFor: $-) ifTrue: [sign _ sign negated].
			value _ Integer readFrom: aStream base: base].
	^ self readRemainderOf: value from: aStream base: base withSign: sign.! !

!Number class methodsFor: '*WASM' stamp: 'jmv 4/27/2019 16:54:05'!
readRemainderOf: integerPart from: aStream base: base withSign: sign
	"Read optional fractional part and exponent, and return the final result"
	| value fraction fracpos peekChar exp scale convertToFloat |

	convertToFloat := false.
	value := integerPart.
	(aStream peekFor: $.)
		ifTrue: [		 "<integer>.<fraction>"
			(aStream atEnd not and: [ aStream peek digitValue between: 0 and: base - 1 ])
				ifTrue:  [
					fracpos := aStream position.
					fraction := Integer readFrom: aStream base: base.
					fraction := fraction / (base raisedToInteger: aStream position - fracpos).
					value := value + fraction.
					convertToFloat := true ]
				ifFalse: [
					"oops - just <integer>."
					aStream skip: -1.
					"un-gobble the period"
					^ value * sign"Number readFrom: '3r-22.2'"]].
	peekChar := aStream peek.
	('deqp' includes: peekChar)
		ifTrue: [			"<number>(e|d|q)<exponent>>" "<number>(p)<binaryExponent>>"
			aStream next.
			(aStream atEnd not and: [ (aStream peek digitValue between: 0 and: 9) or: [ '+-' includes: aStream peek ]])
				ifTrue:  [
					exp := Integer readFrom: aStream.
					scale := (peekChar = $p ifTrue: [2] ifFalse: [base]) raisedToInteger: exp.
					value := value * scale ]
				ifFalse: [
					"oops - just <number>."
					aStream skip: -1.]].
	^convertToFloat
		ifTrue: [
			(value = 0.0 and: [ sign = -1 ])
				ifTrue: [ Float negativeZero ]
				ifFalse: [ (value * sign) asFloat ]]
		ifFalse: [ value * sign ]! !
MemoryCell initialize!
MVP1Spec initialize!
WasmLogger initialize!
